/*
    l_bdb (Blacky Daten Bank fr Linux)

    Dies ist ein einfaches Datenbanksystem fr die Console.

    Copyright (C) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/


*/


#include <curses.h>
#include <signal.h>
#include <stdio.h>
#include <unistd.h>
#include <time.h>
#include "hofmeier.h"
#include <string.h>
#include <errno.h>
#include <stdlib.h>

char *EDITOR;
char *EDITOR2;
char *VIEWER;

// Speichern, ohne Fehlermeldung, beim beenden...
int exitsave = 0;

extern int errno;

char blacky_ver_info[] = "Blacky Daten Bank v1.14 (c) Copyright 1996-2003 Andreas Hofmeier";


static char *eingabe();
/*static void editstr();*/



struct xstatus {
  // Nun, wir wollen hier mal keine Byte-Spalterei betreigen!
  //  unsigned ge : 1;
  //  unsigned sort : 3;
  //  unsigned swhg : 1;
  unsigned char ge;        // Wurde die DB seit dem letztem Speichern verndert?
  unsigned char sort;      // Nach welchem Datenfeld soll sortiert werden?
  unsigned char swhg;      // Programm ist beim Beenden
  unsigned char ge_auto;   // Wurde die DB seit der letzten Auto-Save verndert? (*.bda)
  unsigned char last_auto; // Minute in der zuletzt autosave durchgefhrt wurde
};


struct adr     {
  char *st;
  int *offset;
  int felds;
  struct datensatz;
  struct adr *next;
  struct adr *last;
};


/* function zum Herunterfahren ! */
static void finish(int sig);
/* UHR function */
static void uhr(int sig);
/* Windowsgre gendert */
static void winversch(int sig);

/* Trennziechen */
//unsigned char trz = 0;
/* Im alten Format Schreiben */
char wto = 0;
char frei[5] = "Frei";
char EDD[4] =  {16, 15, 17, 0};/*= "\020\017\021"; */
char BDB1[21] = "Blacky-Daten-Bank-1";
struct xstatus status;         /* Status {gendert? : Sort nach? : System wird Heruntergefahren } */
struct adr *kette_first;       /* Pionter auf das erste Glied in der Kette des DSs */
struct adr *kette_last;        /* Pionter auf das letzte Glied in der Kette des DSs */
struct adr *kette_akt;         /* Pionter auf das acktuelle Glied in der Kette des DSs */
char *Name;                    /* Name der Datenbank */
struct adr *FeldNamen;         /* Feldnamen-Strucktur */
char *datei;                   /* Dateiname */
char *SuchStr;                 /* Letzter eingegebener Such-String */
int maxdfbez = 0;              /* Maximale Lnge der Feldname. Um die ":" richtig zu setzen */
int akt = 0;                   /* Acktueller DS */
int ges = 0;                   /* Gesammtzahl der DS */
char zeigeinfo = 1;            /* Soll die Info-Datei zu den Datenstzen angezeigt werden? */
int zeigeinfo_nachname = -1;   /* Feld im der der Nachname Steht */
int zeigeinfo_vorname = -1;    /* Feld im dem der Voranme steht */
char *zeigeinfo_filename = NULL;/*Dateinamen fr Info-Datei*/
int zeigeinfo_filename_pos = 0;/* Fr welche Possition ist der Dateiname */
int zeigeinfo_file_line = 0;   /* In welcher Zeile ist das Programm gerade? */
char *blktxt;                  /* Wohin mit den Info Dateien? */

int BUFSIZE = 1024;

/* Lnge der normalen "Mll-Arrays" */
#define MULLLEN /*512*/ 256


char *feeldseparator;
int feeldseparatorlen = 0;

// Normal: 8 Datenflder
// In welcher Zeile steht das erste Datenfeld (von 1 beginnend)
int display_first_data_feld_line = 11;
// Wieviele Datenflder sollen angezeigt werden (von 0 beginnend)
int display_data_feld_anz = 7;
// Welches ist das oberste/erste Datenfeld (von 0 beginnend)
int display_first_data_feld = 0;
// Welches ist das unterste/letzte Datenfeld (von 0 beginnend)
int display_last_data_feld = 7 /*display_first_data_feld + display_data_feld_anz*/;

unsigned char *learn_vocable_db = NULL;



/* Gibt ein Datenfeld aus einem Datensatz zurck */
char *GetDataFeld(struct adr *Record, int feld)
{
  static char retNULL[1];

  if (Record != NULL) {
    if (Record->st != NULL) {
      if (feld <= Record->felds) {
	return Record->st + Record->offset[feld];
      } else {
	retNULL[0] = 0;
	return retNULL;
	//	return NULL;
      }
    } else {
      retNULL[0] = 0;
      return retNULL;
      //      return NULL;
    }
  } else {
    retNULL[0] = 0;
    return retNULL;
    //    return NULL;
  }
}


/* Erzeuge neuen Record und fge den DatenSatz st in diesen ein */
struct adr *MakeRecord(char *st)
{
  struct adr *new;
  char *ret;

  // Knoten erzeugen
  pss(new = (struct adr*) malloc(sizeof(struct adr)));
  // ... und String einfgen.
  pss(new->st = (char*) malloc(strlen(st) + 1));
  strcpy(new->st, st);
  // Hm, wir gehen mal von maximal 128 Datenfldern aus...
  pss(new->offset = (int *) malloc(128 * sizeof(int)));
  new->felds = 0;
  // Erstes Feld: Offset: 0
  new->offset[0] = 0;
  // Verwende vorgegebenen FeldSeperator
  if (feeldseparator != NULL) {
    ret = (char *) 1;
    while (ret != NULL) {
      new->offset[new->felds + 1] = ((ret = strstr(new->st + new->offset[new->felds], feeldseparator)) - new->st) + feeldseparatorlen;
      if (ret != NULL) {
	if (new->offset[new->felds] > 0) {
	  new->st[new->offset[new->felds] - feeldseparatorlen] = 0;
	}
	new->felds++;
      }
    }
    if (new->offset[new->felds] > 0) {
      new->st[new->offset[new->felds] - feeldseparatorlen] = 0;
    }
    // Versuche Altes BDB-Format oder ``|''
  } else {
    int len = strlen(new->st);
    int i;
    
    // Alltes Format
    if (((new->st[0] == 14) || (new->st[0] == 15)) &&  (new->st[1] == 1)) {
      new->offset[0] = 2;
      for (i = 2; i < len; i++) {
	if ((new->st[i] == 0) || ((new->st[i] == 11) && ((new->st[i + 1] == 14) || (new->st[i + 1] == 15)))) {
	  new->st[i] = 0;
	  break;
	}
	if ((unsigned char) (new->st[i]) <= 20) {
	  new->st[i] = 0;
	  new->felds++;
	  new->offset[new->felds] = i + 1;
	}
      }
    } else {
      // Trying ``|''
      new->offset[0] = 0;
      for (i = 0; i < len; i++) {
	if (new->st[i] == 0) {
	  break;
	}
	if (new->st[i] == '|') {
	  new->st[i] = 0;
	  new->felds++;
	  new->offset[new->felds] = i + 1;
	}
      }
    }
  }
  pss(new->offset = (int *) realloc(new->offset, ((int) new->felds + 1) * sizeof(int)));
  return new;
}


int CMPRecord(struct adr *new, struct adr *a)
{
  static int i, r;

  if ((r = strcasecmp(GetDataFeld(new, status.sort), GetDataFeld(a, status.sort))) != 0) {
    return r;
  } else {
    for (i = 0; i <= ((a->felds > new->felds) ? new->felds : a->felds); i++) {
      if ((r = strcasecmp(GetDataFeld(new, i), GetDataFeld(a, i))) != 0) {
	return r;
      }
    }
    if (a->felds == new->felds) {
      return 0;
    } else {
      if (a->felds > new->felds) {
	return -1;
      } else {
	return +1;
      }
    }
  }
}


pss(char *s)
{
  if (s == NULL) {
    endwin();
    perror("malloc()");
    fprintf(stderr, "Not enough memory!\n");
    finish(-1);
  }
}


/* Erzeuge neuen Knoten, mit dem Inhalt st, und fge diesen in die Kette ein */
struct adr *newadr(/*char *st*/ struct adr *new)
{
  struct adr /* *new, */ *a;
  int i, newakt = 0;
  char *newstr /* c */, *cmpstr;

  //  new = MakeRecord(st);

  /* Knoten in die Kette einfgen */
  if (kette_first == NULL) {
    /* neue Kette */
    ges = 1;
    kette_first = new;
    kette_last = new;
    kette_akt = new;
    new->last = new;
    new->next = new;
  } else {
    a = kette_first;
    do {
      newakt++;
      /* !!!! Wenn Datensatz identisch, nicht mehr hinzufgen !!!! */
      if ((i = CMPRecord(new, a)) == 0) {
	kette_akt = a;
	akt = newakt;
	/* Knoten Lschen */
	free(new->st);
	free(new->offset);
	free(new);
	return NULL;
      }
      if (i <= 0) {
	akt = newakt;
	ges++;
	if (a == kette_first) {
	  kette_first = new;
	}
	(a->last)->next = new;
	new->last = a->last;
	a->last = new;
	new->next = a;

	kette_akt = new;
	return new;
      }
      a = a->next;
    } while (a != kette_first);

    /* Hinten anhngen */
    akt = ++ges;
    kette_first->last = new;
    kette_last->next = new;
    new->last = kette_last;
    new->next = kette_first;
    kette_last = new;
    kette_akt = new;
  }
  /* Pointer auf neuen Knoten zurckgeben */
  return new;
}


load(char *ldatei)
{
  FILE *f;
  char cd[BUFSIZE];
  int i;
  int lother = 0;
  
  blacky_status_error = 0;
  if (ldatei == NULL) {
    return 0;
  }
  
  if ((f = fopen(ldatei, "r")) != 0) {
    /* Kopfzeile, Dateikennung */
    dosread(f, cd, BUFSIZE);
    if (strncasecmp(cd, BDB1, 19) == 0) {
      // FeeldSeperator
      if ((i = strlen(cd + 19)) == 0) {
	feeldseparator = NULL;
	feeldseparatorlen = 0;
      } else {
	pss(feeldseparator = (char *) malloc(i + 1));
	strcpy(feeldseparator, cd + 19);
	feeldseparatorlen = /*1*/i;
      }
      // Name
      dosread(f, cd, BUFSIZE);
      if (cd[0] != 0) {
	pss(Name = (char *) malloc(strlen(cd) + 1));
	strcpy(Name, cd);
      }
      // Feldnamen
      dosread(f, cd, BUFSIZE);
    BDB_LOAD_FELDNAMES:
      if (isdigit(cd[i = strlen(cd) - 1])) {
	int i2;

	i2 = atoi(cd + i) - 1;
	if ((i2 > 9) || (i2 < 0)) {
	  status.sort = 0;
	} else {
	  status.sort = i2;
	}
	if (cd[i - 1] == '|') {
	  cd[i - 1] = 0;
	} else {
	  cd[i] = 0;
	}
      }
      FeldNamen = MakeRecord(cd);
      maxdfbez = 0;
      // Datensatze
      do {
	dosread(f, cd, BUFSIZE);
      BDB_LOAD_DATA:
	if (((int) strpos(cd, EDD, 1) == (int) -1) && (cd[0] != 0) && (!((cd[0] == 26) && (cd[1] == 0)))) {
	  newadr(MakeRecord(cd));
	} else {
	  if (feof(f)) {
	    break;
	  }
	}
      } while (1);
      if (lother) {
	goto BDB_LOAD_RET_POINT;
      }
      // Dateiname
      pss(datei = (char *) malloc(strlen(ldatei) + 2));
      strcpy(datei, ldatei); 
    } else {
      char ret[50];
      char message[90];

      lother = 1;

      printf("%c%c", 7, 7);
      eingabe(ret, "It's not a Blacky-Daten-Bank! Try load other fromat... ", "", 0);
      // Try load other formats

      //      cd[40] = 0;
      // ** NAME
      sprintf(message, "Is this the DB-Name? (Yes/No) (%s)", cd);
      message[75] = 0;
      eingabe(ret, message, "", 0);
      if ((toupper(ret[0]) == 'Y') || (toupper(ret[0]) == 'J')) {
	pss(Name = (char *) malloc(strlen(cd) + 1));
	strcpy(Name, cd);
	dosread(f, cd, BUFSIZE);
      }

      // ** Feldtrenner
      eingabe(ret, "Pleace ENTER the Feldseperator: ", "|", 0);
      feeldseparatorlen = strlen(ret);
      pss(feeldseparator = (char *) malloc(feeldseparatorlen + 1));
      strcpy(feeldseparator, ret);

      // ** Feeldnames
      sprintf(message, "Are this the DB-Feldnames? (Yes/No) (%s)", cd);
      message[75] = 0;
      eingabe(ret, message, "", 0);
      if ((toupper(ret[0]) == 'Y') || (toupper(ret[0]) == 'J')) {
	goto BDB_LOAD_FELDNAMES;
      } else {
	goto BDB_LOAD_DATA;
      }
    BDB_LOAD_RET_POINT:
    }
  } else {
    printf("%c%c", 7, 7);
    sprintf(cd, "** ERROR: Reading file: %s", sys_errlist[errno]);
    eingabe(cd, cd, "", 0);
  }
  fclose(f);
  /*  if (blacky_status_error != 0) {
      printf("%c%c", 7, 7);
      eingabe(cd, "** ERROR: Reading file!", "", 0);
      }
  */
  return 1;
}


makefnmask()
{
  if (FeldNamen == NULL) {
    pss((char *) (FeldNamen = (struct adr *) malloc(sizeof(struct adr))));
    // ... und String einfgen.
    FeldNamen->st = NULL;
    FeldNamen->offset = NULL;
    FeldNamen->felds = 7;
  }
}


autosave()
{
  int len;

  if (status.ge_auto) {
    status.ge_auto = 0;
    if (datei != NULL) {
      len = strlen(datei);
    
      datei[len - 1]--;
      save();
      datei[len - 1]++;
      status.ge = true;
    } else {
      char newname[] = "/tmp/noname.bda";
      datei = newname;
      save();
      datei = NULL;
      status.ge = true;
    }
  }
}


save()
{
  FILE *f;
  char cd[BUFSIZE];
  int i;
  char *apointer;
  struct adr *a;

  errno = 0;

  /* Wenn kein Dateiname, Speichern unter */
  blacky_status_error = 0;
  if (datei == NULL) {
    saveas();
    return;
  }
  /* Dafr sorgen, dass Feldnamen verhanden sind */
  makefnmask();
  /* BackUp von der Datei */
  bsk(datei);
  /* Speichern... */
  if ((f = fopen(datei, "w")) == NULL) {
    sprintf(cd, "** ERROR: Writing file %s: %s", datei, sys_errlist[errno]);
    if (exitsave == 0) {
      eingabe(cd, cd, "", 0);
    } else {
      fprintf(stderr, "%c%s\n", 7, cd);
    }
    return 0;
  }
  /* Dateikennung */
  if (wto) {
    doswrite(f, BDB1);
  } else {
    if (feeldseparatorlen > 0) {
      fprintf(f, "%s%s\n", BDB1, feeldseparator);
    } else {
      fputs(BDB1, f);
      fwrite("\n", 1, 1, f);
    }
  }
  /* Schreibt Name und Feldnamen */
  if (Name != NULL) {
    if (wto) {
      doswrite(f, Name);
    } else {
      fputs(Name, f);
      fwrite("\n", 1, 1, f);
    }
  } else {
    if (wto) {
      doswrite(f, "");
    } else {
      //      fputs("", f);
      fwrite("\n", 1, 1, f);
    }
  }
  if (FeldNamen != NULL) {
    if (FeldNamen->st != NULL) {
      for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 7); i++) {
	if (wto) {
	  if (i == 0) {
	    fprintf(f, "%c%c", 14, 1);
	  }
	}
	apointer = GetDataFeld(FeldNamen, i);
	fwrite(apointer, strlen(apointer), 1, f);
	if (wto) {
	  if (i == 7) {
	    fprintf(f, "%c%c%d%c\n", 11, 14, status.sort + 1, 13);
	  } else {
	    fprintf(f, "%c", i + 2);
	  }
	} else {
	  if (feeldseparatorlen > 0) {
	    if (i < ((FeldNamen != NULL) ? FeldNamen->felds : 7)) {
	      fwrite(feeldseparator, feeldseparatorlen, 1, f);
	    } else {
	      //	    fputs("", f);
	      //	    fwrite(feeldseparator, feeldseparatorlen, 1, f);
	      fprintf(f, "|%d\n", status.sort + 1);
	      //	    fwrite("\n", 1, 1, f);
	    }
	  } else {
	    fwrite("|", 1, 1, f);
	    if (i == ((FeldNamen != NULL) ? FeldNamen->felds : 7)) {
	      fprintf(f, "%d\n", status.sort + 1);
	    }
	  }
	}
      }
    } else {
      goto SAVE_WRITE_EMPTY_FELD_NAMES;
    }
  } else {
    goto SAVE_WRITE_EMPTY_FELD_NAMES;
  }
  if (0) {
  SAVE_WRITE_EMPTY_FELD_NAMES:
    if (wto) {
      fprintf(f, "%c%c%c%c%c%c%c%c%c%c%c1%c\n", 14, 1, 2, 3, 4, 5, 6, 7, 8, 11, 14, 13);
    } else {
      //      fputs("", f);
      fwrite("\n", 1, 1, f);
    }
  }
  /* Schreiben der Datenstze */
  if (kette_first != NULL) {
    a = kette_first;
    do {
      for (i = 0; i <= a->felds; i++) {
	if (wto) {
	  if (i == 0) {
	    fprintf(f, "%c%c", 15, 1);
	  }
	}
	apointer = GetDataFeld(a, i);
	fwrite(apointer, strlen(apointer), 1, f);
	if (wto) {
	  if (i == 7) {
	    fprintf(f, "%c%c%c\n", 11, 15, 13);
	  } else {
	    fprintf(f, "%c", i + 2);
	  }
	} else {
	  if (feeldseparatorlen > 0) {
	    if (i < ((a != NULL) ? a->felds : 7)) {
	      fwrite(feeldseparator, feeldseparatorlen, 1, f);
	    } else {
	      fwrite("\n", 1, 1, f);
	    }
	  } else {
	    if (i < a->felds) {
	      fwrite("|", 1, 1, f);
	    } else {
	      //	      fputs("", f);
	      fwrite("\n", 1, 1, f);
	    }
	  }
	}
      }
      a = a->next;
    } while (a != kette_first);
  }
  if (wto == 1) {
    doswrite(f, EDD);
  }
  ffsync(f);
  fclose(f);

  /* Fehler Aufgetreten? */
  if (blacky_status_error != 0) {
    sprintf(cd, "** ERROR: Writing file %s: %s", datei, sys_errlist[errno]);
    if (exitsave == 0) {
      eingabe(cd, cd, "", 0);
    } else {
      fprintf(stderr, "%c%s\n", 7, cd);
    }
  } else {
    int len = strlen(datei);

    status.ge = false;
    status.ge_auto = false;

    datei[len - 1]--;
    if ((filelen(datei) > 0) && (datei[len - 1] == 'a')) {
      remove(datei);
      datei[len] = '~';
      datei[len + 1] = 0;
      remove(datei);
      datei[len] = 0;
    }
    datei[len - 1]++;
  }
}


/* mod = 0: Mormal
       = 1: Mit ZeigeInfo */
paint(mod)
  char mod;
{
  int i, i2;
  char cd[MULLLEN]/*, cd2[MULLLEN]*/;

  // kein Cursor
  curs_set(0);

  if (status.swhg) {
    return;
  }
  echo();

  // berprfe, ob anzuzeigenden Felder Vorhanden sind
  if (display_first_data_feld < 0 || ((FeldNamen != NULL) ? display_first_data_feld > FeldNamen->felds : 1 /*7*/)) {
    display_first_data_feld = 0;
    display_last_data_feld = 7;
  }
  if (((FeldNamen != NULL) ? FeldNamen->felds : 7) < display_last_data_feld) {
    display_last_data_feld = (FeldNamen != NULL) ? FeldNamen->felds : 7;
    if ((display_first_data_feld + display_last_data_feld) > 7) {
      if ((display_first_data_feld = display_last_data_feld - 7) < 0) {
	display_first_data_feld = 0;
      }
    }
  }
  // Finde heraus, wie lang der Lngste Feldname ist
  if ((maxdfbez == 0) && (FeldNamen != NULL) && (FeldNamen->st != NULL)) {
    for (i = display_first_data_feld; i <= display_last_data_feld; i++) {
      if ((i2 = strlen(GetDataFeld(FeldNamen, i))) > maxdfbez) {
	maxdfbez = i2;
      }
    }
  }
  // ... darf nicht ber 25 sein
  if (maxdfbez > 25) {
    maxdfbez = 25;
  }

  makeline(LOECK, HLINE, ROECK, 1, 1);
  makeline(VLINE, NOMBG, VLINE, 1, 2);
  gotoxy(3, 2);
  addstr(blacky_ver_info);
  makeline(RABGE, HLINE, LABGE, 1, 3);
  makeline(VLINE, NOMBG, VLINE, 1, 4);
  gotoxy(3, 4);
  addstr("Datenbank:");
  makeline(VLINE, NOMBG, VLINE, 1, 5);
  gotoxy(3, 5);
  addstr("Name     :");
  makeline(RABGE, HLINE, LABGE, 1, 6);
  makeline(VLINE, NOMBG, VLINE, 1, 7);
  makeline(VLINE, NOMBG, VLINE, 1, 8);
  makeline(VLINE, NOMBG, VLINE, 1, 9);
  if (((FeldNamen != NULL) ? FeldNamen->felds : 0) <= 7) {
    gotoxy(3, 7);
    addstr("x=Exit UP,DN=Select F2=Save F4=Save As /,n=Search ?=Edit Info");
    gotoxy(3, 8);
    addstr("N=Edit DB Name F=Edit Feld Names INS=New ENTER=Edit DEL=Erase");
    gotoxy(3, 9);
    addstr("S=Sort by D=Print P=Print DS Space=Redraw i=License Info");
    makeline(RABGE, HLINE, LABGE, 1, 10);
  } else {
    makeline(VLINE, NOMBG, VLINE, 1, 10);
    // Display 12 Datafelds
    display_first_data_feld_line = 7;
    display_data_feld_anz = 11;
    display_first_data_feld = 0;
    display_last_data_feld = display_first_data_feld + display_data_feld_anz;
  }
  makeline(VLINE, NOMBG, VLINE, 1, 11);
  makeline(VLINE, NOMBG, VLINE, 1, 12);
  makeline(VLINE, NOMBG, VLINE, 1, 13);
  makeline(VLINE, NOMBG, VLINE, 1, 14);
  makeline(VLINE, NOMBG, VLINE, 1, 15);
  makeline(VLINE, NOMBG, VLINE, 1, 16);
  makeline(VLINE, NOMBG, VLINE, 1, 17);
  makeline(VLINE, NOMBG, VLINE, 1, 18);
  makeline(RABGE, HLINE, LABGE, 1, 19);
  makeline(VLINE, NOMBG, VLINE, 1, 20);
  makeline(VLINE, NOMBG, VLINE, 1, 21);
  makeline(VLINE, NOMBG, VLINE, 1, 22);
  makeline(VLINE, NOMBG, VLINE, 1, 23);
  makeline(LUECK, HLINE, RUECK, 1, 24);
  /* Feldnamen */
  i2 = 0;
  if ((maxdfbez != 0) && (FeldNamen != NULL) && (FeldNamen->st != NULL)) {
    for (i = display_first_data_feld; i <= display_last_data_feld; i++) {
      gotoxy(3, i2 + display_first_data_feld_line);
      sprintf(cd, "%s                                             ", GetDataFeld(FeldNamen, i));
      //      sprintf(cd, "%.*s :", maxdfbez, GetDataFeld(FeldNamen, i));
      cd[maxdfbez + 1] = ':';
      cd[maxdfbez + 2] = 0;
      addstr(cd);
      i2++;
    }
  }
  i2 = 0;
  // Aktuellen Datensatz anzeigen
  if (kette_first != NULL) {
    for (i = display_first_data_feld; i <= display_last_data_feld; i++) {
      gotoxy(maxdfbez + 6, i2 + display_first_data_feld_line);
      sprintf(cd, "%.*s", /* 80-x*/ 73 - maxdfbez, GetDataFeld(kette_akt, i));
      addstr(cd);
      i2++;
    }
  }
  // Dateiname
  if (datei != NULL) {
    gotoxy(14, 4);
    addstr(datei);
  }
  // Datenbankname
  if (Name != NULL) {
    gotoxy(14, 5);
    addstr(Name);
  }
  // Gendert?
  if (status.ge) {
    gotoxy(3, 19);
    addstr("*");
  }
  // Sordet by?
  gotoxy(5, 19);
  sprintf(cd, "(%d)", status.sort + 1);
  addstr(cd);
  // Position
  if (kette_akt != NULL) {
    if (kette_akt == kette_last) {
      gotoxy(9, 19);
      addstr("[END]");
      akt = ges;
    } else {
      if (kette_akt == kette_first) {
	gotoxy(9, 19);
	addstr("[HOME]");
	akt = 1;
      } else {
	gotoxy(9, 19);
	sprintf(cd, "[%02d%%]", (int) ((double) (100) /*8*/ * ((double) (akt - 1) / (double) (ges))));
	addstr(cd);
      }
    }
  } else {
    gotoxy(9, 19);
    addstr("[NONE]");
  }
  // Nummer des Aktuellen DS / Von insgesammt DS
  gotoxy(65, 19);
  sprintf(cd, "%d/%d", akt, ges);
  addstr(cd);
  // Learn DB
  if (learn_vocable_db != NULL) {
    gotoxy(30, 19);
    sprintf(cd, "R:%02d W:%02d I:%02d", learn_vocable_db[(akt - 1) * 3 + 0], learn_vocable_db[(akt - 1) * 3 + 1], learn_vocable_db[(akt - 1) * 3 + 2]);
    addstr(cd);
  }
  /* Scroll Bar */
  i = (int) ((double) (display_data_feld_anz + 1) /*8*/ * ((double) (akt - 1) / (double) (ges)));
  gotoxy(1, i + display_first_data_feld_line /*11*/);
  addstr("#");
  
  noecho();
  /* Aufruf der UHR-Function */
  uhr(128);
  /*  
      Knnen raus, das uhr das bernimmt !
      gotoxy(14, 23); 
      refresh();
  */
  if ((zeigeinfo == 1) && (mod == 1)) {
    paint_info();
  }
  refresh(); 
}



// suche Datenfelder-Index, in denen Vorname und Nachname abgelegt werden
paint_info_get_feld()
{
  char *apointer;
  int i;

  if ((zeigeinfo_nachname >= 0) || (zeigeinfo_vorname >= 0)) {
    return;
  }
  if (kette_last == NULL) {
    return;
  }
  
  for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 7); i++) {
    apointer = GetDataFeld(FeldNamen, i);
    if ((strcasecmp(apointer, "name") == 0) || (strcasecmp(apointer, "nachname") == 0) || (strcasecmp(apointer, "lastname") == 0) || (strcasecmp(apointer, "surname") == 0) || (strcasecmp(apointer, "family name") == 0) || (strcasecmp(apointer, "familyname") == 0)) {
      zeigeinfo_nachname = i;
    }
    if ((strcasecmp(apointer, "vorname") == 0) || (strcasecmp(apointer, "firstname") == 0) || (strcasecmp(apointer, "first name") == 0) || (strcasecmp(apointer, "forename") == 0)) {
      zeigeinfo_vorname = i;
    }
  }
}
 

// Erzeuge Dateinamen fr Notitz aus Datensatz
paint_info_get_filename(int akt, struct adr *kette_akt)
{
  int i;
  char *s0, *s1, s2[400];
  
  if (zeigeinfo_filename_pos == akt) {
    return;
  }
  if (kette_last == NULL) {
    return;
  }
  if (kette_akt->st == NULL) {
    return;
  }
  if ((zeigeinfo_nachname < 0) || (zeigeinfo_vorname < 0)) {
    return;
  }
  s0 = GetDataFeld(kette_akt, zeigeinfo_nachname);
  s1 = GetDataFeld(kette_akt, zeigeinfo_vorname);
  sprintf(s2, "%s/pb.%s.%s.txt", blktxt, s1, s0);
  for (i = 0; s2[i] != 0; i++) {
    if (s2[i] == ' ' || (s2[i] == '(') || (s2[i] == ')') || (s2[i] == '\'') || (s2[i] == '\"'))	{
      s2[i] = '_';
    }
  }
  free(zeigeinfo_filename);
  zeigeinfo_filename = (char *) malloc(strlen(s2) + 1);
  if (zeigeinfo_filename != NULL) {
    strcpy(zeigeinfo_filename, s2);
  }
  zeigeinfo_filename_pos = akt;
}


// Anzeigen der Notitz/Info-Datei in den Unt
paint_info()
{
  FILE *f;
  char s[BUFSIZE];
  int i;

  paint_info_get_feld();
  paint_info_get_filename(akt, kette_akt);

  if ((f = fopen(zeigeinfo_filename, "r")) == NULL) {
    return;
  }
  for (i = 20; i < 24; i++) {
    dosread(f, s, BUFSIZE);
    gotoxy(3, i);
    addstr(s);
  }
  fclose(f);

  if (zeigeinfo_file_line != 0) {
    zeigeinfo_file_line = 0;
  }
}


paint_info_newline()
{
  char s[MULLLEN];
  FILE *f;
  int i;

  if (zeigeinfo_file_line == 0) {
    paint_info_get_feld();
    paint_info_get_filename(akt, kette_akt);
  }
  zeigeinfo_file_line++;

  if ((f = fopen(zeigeinfo_filename, "r")) != NULL) {
    // n-Zeilen berspringen
    for (i = 0; i < zeigeinfo_file_line; i++) {
      dosread(f, s, MULLLEN);
    }
    for (i = 20; i < 24; i++) {
      makeline(VLINE, NOMBG, VLINE, 1, i);
      s[0] = 0;
      dosread(f, s, BUFSIZE);
      gotoxy(3, i);
      addstr(s);
    }
  }
  if (f != NULL) {
    fclose(f);
  }

  // ... scheie, ich wei!
}


static char *eingabe(result, was, def, al)
  char *result;
  char was[];
  char def[];
  int al;
{
  char i;

  // Cursor on
  curs_set(1);

  makeline(VLINE, NOMBG, VLINE, 1, 20);
  makeline(VLINE, NOMBG, VLINE, 1, 21);
  makeline(VLINE, NOMBG, VLINE, 1, 22);
  makeline(VLINE, NOMBG, VLINE, 1, 23);

  echo();
  gotoxy(3, 20);
#ifdef BLACKY_cur_Graphik
  attrset(A_STANDOUT);
#endif
  addstr(was);
#ifdef BLACKY_cur_Graphik
  attrset(A_NORMAL);
#endif
  if ((def[0] == 0) && (!((def[0] == ' ') && (def[1] == 0)))) {
    gotoxy(3, 21);
    refresh(); 
    result[0] = 0;
    editstr(result, 20, 2, al);
  } else {
    result[0] = 0;
    result[1] = 0;
    if (!((def[0] == ' ') && (def[1] == 0))) {
      strcpy(result, def);
    }
    editstr(result, 20, 2, al);
  }
  paint(1);
  noecho();

  // Cursor off
  curs_set(0);

  return result;
}


// berprft, ob der zu Suchende String in der zum DatanSatz gehrigen
// Datei vorhanden ist
ifstringineds(int newakt, struct adr *a) {
  FILE *f;
  char s[MULLLEN];
  char mull[MULLLEN];

  paint_info_get_feld();
  zeigeinfo_filename_pos = 0;
  paint_info_get_filename(-1, a);

  if ((f = fopen(zeigeinfo_filename, "r")) == NULL) {
    return;
  }
  while (!feof(f)) {
    dosread(f, s, MULLLEN);
    Gross(mull, s);
    if (strpos(mull, SuchStr, 0) > (int) -1) {
      kette_akt = a;
      akt = newakt;
      paint(0); // Anzeigen ohne Info Zeile
      // Info-Zeile Selber Anzeigen
      gotoxy(3, 20);
      addstr(s);
      dosread(f, s, MULLLEN);
      gotoxy(3, 21);
      addstr(s);
      fclose(f);
      return 1;
    }
  }
  return 0;
}


suche(newakt, a)
  int newakt;
  struct adr *a;
{
  char mull[MULLLEN];
  int i;

  if (kette_last == NULL) {
    return;
  }

  do {
    newakt++;
    for (i = 0; i <= a->felds; i++) {
      Gross(mull, GetDataFeld(a, i));
      if (strpos(mull, SuchStr, 0) > (int) -1) {
	kette_akt = a;
	akt = newakt;
	return;
      }
    }
    if (ifstringineds(newakt, a) == 1) {
      return;
    }
    a = a->next;
  } while (a != kette_first);
}


suchen ()
{
  char cd[MULLLEN], mull[MULLLEN];
  struct adr *a;

  cd[0] = 0;
  sprintf(mull, "search");
  if (SuchStr != NULL) {
    eingabe(cd, mull, SuchStr, 0);
  } else {
    eingabe(cd, mull, "", 0);
  }
  if (SuchStr == NULL) {
    SuchStr = (char*) malloc(1);
    SuchStr[0] = 0;
  }
  if (0 != strcmp(cd, SuchStr)) {
    free(SuchStr);
    pss(SuchStr = (char*) malloc(strlen(cd) + 1));
    Gross(SuchStr, cd);
    a = kette_first;
    suche(0, a);
  } else {
    if (SuchStr != NULL) {
      a = kette_akt->next;
      /* akt -1 wegen ++ und akt + 1 wegen dem einen nach vornespringen*/
      suche(akt, a);
    }
  }
  paint(1);
}


wsuchen()
{
  struct adr *a;

  if (SuchStr == NULL) {
    return;
  }

  a = kette_akt->next;
  /* akt -1 wegen ++ und akt + 1 wegen dem einen nach vornespringen*/
  suche(akt, a);
  paint(1);
}


killadr(a)
  struct adr *a;
{
  if (kette_last == NULL) {
    return;
  }

  /* Pointer umpointen */
  (a->last)->next = a->next;
  (a->next)->last = a->last;
  /* Aktuell auf next setzen */
  kette_akt = a->next;
  if (kette_last == kette_first) {
    kette_last = NULL;
    kette_first = NULL;
  } else {
    if (a == kette_last) {
      kette_last = a->last;
    }
    if (a == kette_first) {
      kette_first = a->next;
    }
  }
  /* Knoten Lschen */
  free(a->st);
  free(a->offset);
  free(a);
  /* gesamtzahl anpassen */
  ges--;
}


editds()
{
  char message[MULLLEN], messageret[MULLLEN], oldstr[MULLLEN], newstr[BUFSIZE];
  int i;
  int len = 0;
  struct adr *new;
  int felds;

  makefnmask();
  if (kette_last == NULL) {
    return;
  }

  newstr[0] = 0;

  if (kette_akt != NULL) {
    if ((felds = kette_akt->felds) == 0) {
      felds = 7;
    }
  } else {
    return;
    //    felds = 7;
  }

  for (i = 0; i <= felds; i++) {
    sprintf(message, "Edit record: ENTER %s: ", GetDataFeld(FeldNamen, i));
    strcpy(oldstr, GetDataFeld(kette_akt, i));
    if (oldstr[0] == 0) {
      oldstr[0] = ' ';
      oldstr[1] = 0;
    }
    eingabe(messageret, message, oldstr, 1);
    strcat(newstr, messageret);
    if (i < felds) {
      if (feeldseparatorlen > 0) {
	//	len = strlen(message) + feeldseparatorlen;
	strcat(newstr, feeldseparator);
      } else {
	len = strlen(newstr) + 1;
	newstr[len - 1] = '|';
	newstr[len] = 0;
      }
    }
  }
  new = MakeRecord(newstr);
  if (0 != CMPRecord(kette_akt, new)) {
    killadr(kette_akt);
    newadr(new);
    status.ge = true;
    status.ge_auto = true;
  }
  //  paint(0);
  maxdfbez = 0;
  paint(1);
}


exitbdb()
{
  char cd[5];

  if (!status.ge) {
    gotoxy(1, 25);
    donebdb();
  }
  eingabe(cd, "Database not saved! Save? (Yes/No/Cancel)", "", 0);
  if (toupper(cd[0]) == 'Y' || toupper(cd[0]) == 'J') {
    save();
    gotoxy(1, 25);
    donebdb();
  }
  if (toupper(cd[0]) == 'N') {
    gotoxy(1, 25);
    donebdb();
  }
}


editfn()
{
  char message[MULLLEN], messageret[MULLLEN], oldstr[MULLLEN], newstr[BUFSIZE];
  int i;
  int len = 0;
  struct adr *new;
  int felds;

  makefnmask();

  newstr[0] = 0;

  /*
  if (FeldNamen != NULL) {
    if ((felds = FeldNamen->felds) == 0) {
      felds = 7;
    }
  } else {
    felds = 7;
  }
  */

  for (i = 0; /*i <= felds*/; i++) {
    sprintf(message, "ENTER name of datafeld %d (`.' - not more datafelds) :", i + 1);
    strcpy(oldstr, GetDataFeld(FeldNamen, i));
    if (oldstr[0] == 0) {
      oldstr[0] = ' ';
      oldstr[1] = 0;
    }
    eingabe(messageret, message, oldstr, 1);
    if ((messageret[0] == '.') && (messageret[1] == 0)) {
      break;
    }
    if (i > 0) {
      if (feeldseparatorlen > 0) {
	//	len = strlen(message) + feeldseparatorlen;
	strcat(newstr, feeldseparator);
      } else {
	len = strlen(newstr) + 1;
	newstr[len - 1] = '|';
	newstr[len] = 0;
      }
    }
    strcat(newstr, messageret);
  }
  new = MakeRecord(newstr);
  if (0 != CMPRecord(FeldNamen, new)) {
    if (FeldNamen->st != NULL) {
      free(FeldNamen->st);
    }
    if (FeldNamen->offset != NULL) {
      free(FeldNamen->offset);
    }
    FeldNamen->st = new->st;
    FeldNamen->felds = new->felds;
    FeldNamen->offset = new->offset;
    free(new);
    status.ge = true;
    status.ge_auto = true;
  }
  //  paint(0);
  maxdfbez = 0;
  paint(1);
}


saveas()
{
  char mull[MULLLEN], cd[MULLLEN];
  int len;

  if (kette_last == NULL) {
    return;
  }
  strcpy(mull, "Saveas (* = != bdb) (ESC, ENTER Chancel): ");
  if (datei != NULL) {
    eingabe(cd, mull, datei, 1);
  } else {
    eingabe(cd, mull, "namenlos.bdb", 1);
  }

  if (cd[0] == 0) {
    return;
  }

  len = strlen(cd);
  if (cd[len - 1] != '*') {
    if (cd[len - 4] != '.') {
      if (cd[len - 1] != '.') {
	strcat(cd, ".bdb");
      }
    }
  } else {
    cd[strlen(cd) - 1] = 0;
  }
  free(datei);
  pss(datei = (char*) malloc(strlen(cd) + 2));
  strcpy(datei, cd);
  save();
  paint(1);
}


dsptenp()
{
  int i;
  if (kette_last == NULL) {
    return;
  }

  for (i = (double) ges * 0.1; i > 0; i--) {
    kette_akt = kette_akt->next;
    akt++;
    if (kette_akt == kette_first) {
      akt = 1;
    }
  }
  paint(1);
}


dsmtenp()
{
  int i;
  if (kette_last == NULL) {
    return;
  }

  for (i = (double) ges * 0.1; i > 0; i--) {
    kette_akt = kette_akt->last;
    akt--;
    if (kette_akt == kette_last) {
      akt = ges;
    }
  }
  paint(1);
}


dsnext()
{
  if (kette_last == NULL) {
    return;
  }
  kette_akt = kette_akt->next;
  akt++;
  // Erledigt paint()
  //  if (akt > ges) {
  //    akt = 1;
  //  }
  paint(1);
}


dstohome()
{
  if (kette_last == NULL) {
    return;
  }
  kette_akt = kette_first;
  /* akt = 1; (erlediigt paint) */
  paint(1);
}


dstoend()
{
  if (kette_last == NULL) {
    return;
  }

  kette_akt = kette_last;
  /* akt = ges; (erlediigt paint) */
  paint(1);
}


dslast()
{
  if (kette_last == NULL) {
    return;
  }

  kette_akt = kette_akt->last;
  akt--;
  // Erledigt paint()
  //  if (akt < 1) {
  //    akt = ges;
  //  }
  paint(1);
}


dsnew()
{
  char message[MULLLEN], oldstr[MULLLEN], newstr[BUFSIZE], messageret[MULLLEN];
  int i;
  int len = 0;
  struct adr *new;

  makefnmask();

  newstr[0] = 0;

  for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 7); i++) {
    sprintf(message, "New record: ENTER %s: ", GetDataFeld(FeldNamen, i));
    oldstr[0] = ' ';
    oldstr[1] = 0;
    eingabe(messageret, message, oldstr, 1);
    strcat(newstr, messageret);
    if (i < ((FeldNamen != NULL) ? FeldNamen->felds : 7)) {
      if (feeldseparatorlen > 0) {
	len = strlen(message) + feeldseparatorlen;
	strcat(newstr, feeldseparator);
      } else {
	len = strlen(newstr) + 1;
	newstr[len - 1] = '|';
	newstr[len] = 0;
      }
    }
  }
  if (newadr(MakeRecord(newstr)) != NULL) {
    status.ge = true;
    status.ge_auto = true;
  }
  paint(1);
}


dskill()
{
  char cd[5];

  if (kette_last == NULL) {
    return;
  }
  paint(0);
  eingabe(cd, "Do you want really erase this record? (Yes/No):", "", 0);
  if (toupper(cd[0]) == 'J' || toupper(cd[0]) == 'Y') {
    killadr(kette_akt);
    status.ge = true;
    status.ge_auto = true;
  }
  paint(1);
}


editdbname()
{
  char mull[MULLLEN], cd[MULLLEN];

  strcpy(mull, "ENTER new name of database: ");
  if (Name != 0) {
    eingabe(cd, mull, Name, 1);
    if (0 == strcmp(cd, Name)) {
      return;
    }
    free(Name);
  } else {
    eingabe(cd, mull, " ", 0);
  }
  if (cd[0] == 0) {
    return;
  }
  pss(Name = (char*) malloc(strlen(cd) + 1));
  strcpy(Name, cd);
  status.ge = true;
  status.ge_auto = true;
  paint(1);
}


setsort()
{
  char cd[MULLLEN];
  int i;

  eingabe(cd, "By which datafeld shall be sort this databank? (1-...)", "", 0);
  if (cd[0] != 0) {
    i = atoi(cd);
    if (i < 9 && i > 0) {
      status.sort = i - 1;
      status.ge = true;
      status.ge_auto = true;
      eingabe(cd, "This change will apply after restart.", "", 0);
    }
  }
}


donebdb()
{
  char mull[MULLLEN];

  if (status.ge) {
    if (datei == NULL) {
      sprintf(mull, "%s%s%c", getenv("HOME"), "/NAMENLOS.BDA", 0);
      datei = (char *) malloc(strlen(mull) + 2);
      strcpy(datei, mull);
    } else {
      datei[strlen(datei) - 1] = datei[strlen(datei) - 1] - 1;
    }
    save();
  }
  finish(1);
}


drucken_a_lot_of(s, m, z)
  char s[], z;
  int m;
{
  int i;

  for (i = 0; i < m; i++) {
    if (s[i] != z)
      s[i] = z;
  }
  s[i] = 0;
}


drucken()
{
  int z, i, j,  x[((FeldNamen != NULL) ? FeldNamen->felds : 7) + 1];
  char au[((FeldNamen != NULL) ? FeldNamen->felds : 7) + 1];
  struct adr *a;
  FILE *f;
  char s0[60], s[MULLLEN], mull[MULLLEN], wohin[MULLLEN], command[MULLLEN];
  char m = 0;

  /* Langenarray auf NULL setzen */
  for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 7); i++) {
    x[i] = 0;
    au[i] = i;
  }
  /* Wenn Keine Datenbank Geladen, dann EXIT */
  if (kette_first == NULL) {
    return;
  }
  /* Laden der prn File, wenn verhanden. */
  sprintf(wohin, "%s.prn", datei);
  j = 0;
  if (!((f = fopen(wohin, "r")) == NULL)) {
    eingabe(mull, "Mchten Sie die alten Configurationen Benutzen (y/n)? (\".\" + ENTER = Abb.)", "y", 1);
    if (mull[strlen(mull) - 1] == '.') {
      return;
    }
    if (toupper(mull[0]) == 'Y') {
      j = 1;
    }
    if (toupper(mull[0]) == 'J') {
      j = 1;
    }
  }
  if (j == 1) {
    fread(&x, sizeof(x), 1, f);
    readastring(f, wohin);
    fread(au, ((FeldNamen != NULL) ? FeldNamen->felds + 1 : 8), 1, f);
    if (fread(&m, 1, 1, f) != 1){
      m = 0;
    }
    fclose(f);
    f = NULL;
  } else {
    /* Standart Druckeroutput */
    strcpy(wohin, " ");
    /* Ermitteln der Lngen */
    a = kette_first;
    do {
      for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 7); i++) {
	j = strlen(strcpy(mull, GetDataFeld(a, i)));
	if (j > x[i]) {
	  x[i] = j;
	}
      }
      a = a->next;
    } while (a != kette_first);
  }
  do {
    clear();
    addstr(">");
    for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 7); i++) {
      if (x[au[i]] != -1) {
	strcpy(mull, GetDataFeld(FeldNamen, au[i]));
	mull[x[au[i]]] = 0;
	sprintf(s, "  %c-%ds", '%', x[au[i]]);
	sprintf(command, s, mull);
	addstr(command);
      }
    }
    addstr("<\n\n");
    addstr("Modus: \n");
    if (m == 0) {
      addstr("normal\n");
    }
    if (m == 1) {
      addstr("DOS - GRA\n");
    }
    if (m == 2) {
      addstr("HTML\n");
    }

    for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 7); i++) {
      s0[0] = i + 97;
      s0[1] = 0;
      addstr("  ");
      addstr(s0);
      addstr("-");
      addstr(GetDataFeld(FeldNamen, au[i]));
      sprintf(mull, "-%d; ", x[au[i]]);
      addstr(mull);
    }
    addstr("\n\n");
    addstr("Mchten sie diese Gre Beibehalten?\n  Drcken sie ENTER um die Tabelle fertigzustellen,\n  oder die Zahlen von 1-n, um die Lnge eine Spalte zu ndern,\n  a-[n] um einer Spalte ein Datenfeld zuzuordnen.\n  M - Modus (0: ASCII/1: DOS/2: HTML)\n\n  ESC - ABBRECHEN\n");
    j = getch();
    if ((j > 48) && (j < 58)) {
      /*      i = 0;
      for (z = 0; z <= 7; z++) {
	i = i + 2 + x[z];
      }
      z = j - 48;*/
      s[0] = j;
      s[1] = 0;
      editstr(s, 20, 0, 1);
      z = atoi(s) - 1;
      if ((z >= 0) && (z <= ((FeldNamen != NULL) ? FeldNamen->felds : 7))) {
	sprintf(mull, "\nNeue Breite des Datenfeldes %s. In Zeichen. (Gesamt: %d) (%d)", GetDataFeld(FeldNamen, z - 1), i, x[au[z - 1]]);
	addstr(mull);
	sprintf(s, "%d", x[au[z]]);
	editstr(s, 20, 0, 1);
	/*	  if (atoi(s) != 0) */
	x[au[z]] = atoi(s);
      }
    }
    if ((j > 96) && (j < /*105*/ 123)) {
      z = j - 97; /* -96 Ascii; -1 */
      if ((z >= 0) && (z <= ((FeldNamen != NULL) ? FeldNamen->felds : 7))) {
	addstr("\nTabelle: XXXX\n");
	mull[0] = ' ';
	mull[1] = ' ';
	mull[2] = ' ';
	mull[4] = 0;
	for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 7); i++) {
	  mull[3] = i + 65;
	  addstr(mull);
	}
	addstr("\n  ------------------------\n");
	for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 7); i++) {
	  sprintf(mull, "%4d", au[i] + 1);
	  addstr(mull);
	}
	sprintf(mull, "\nWelches Datenfeld soll in Spalte %c stehen?: ", j);
	addstr(mull);
	echo();
	/*getstr(mull);*/
	/*i = getch();*/
	eingabe(mull, "", "", 0);
	noecho();
	
	j = atoi(mull) - 1;
	if ((j >= 0) && (j <= ((FeldNamen != NULL) ? FeldNamen->felds : 7))) {
	  au[z] = j;
	}
      }
    }
    if (toupper(j) == 'M') {
      sprintf(s, "\nENTER MODUS:\n  0.) Normal\n  1.) DOS-Graphik\n  2.) HTML\n");
      addstr(s);
      eingabe(mull, "", "", 0);
      if ((mull[0] > 47) &&(mull[0] < 51)) {
	m = (mull[0] - 48);
      }
    }
    if (j == 27) {
      paint(1);
      return;
    }
  } while (j != 13);
  paint(0);
  /* Zieldatei Feststellen, und ffnen */
  strcpy(mull, wohin);
  eingabe(wohin, "Wohin mit der Ausgabe ?", mull, 1);
  bsk(wohin);
  f = fopen(wohin, "w");
  if (m != 2) {
    fprintf(f, "Tabelle: %s\n", Name);
  }
  /* Kopfzeile, nur bei DOS-GRA und HTML */
  if (m == 1) {
    fprintf(f, "%c<  %c%c", 27, 201, 205);
    for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 7); i++) {
      if (x[au[i]] != 0) {
	drucken_a_lot_of(mull, x[au[i]], 205);
	if (i != 0) {
	  fprintf(f, "%c%c%s%c", 209, 205, mull, 205);
	} else {
	  fprintf(f, "%s%c", mull, 205);
	}
      }
    }
    fprintf(f, "%c%c%c", 187, 13, 10);
    fprintf(f, "%c<  %c ", 27, 186);
  }
  if (m == 2) {
    fprintf(f, "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML//EN\">\n<html>\n  <head>\n    <title>Tabelle: %s</title>\n  </head>\n\n  <body>\n    <h1>Tabelle: %s</h1>\n    <table>\n      <tr>\n", Name, Name);
  }

  /* Schreiben der FeldNamen */
  for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 7); i++) {
    if (x[au[i]] != -1) {
      strcpy(mull, GetDataFeld(FeldNamen, au[i]));
      mull[x[au[i]]] = 0;
      if (m == 0) {
	if (i == 0) {
	  fwrite(" ", 1, 1, f);
	}
	sprintf(s, " %c-%ds", '%', x[au[i]]);
	fprintf(f, s, mull);
      }
      if (m == 1) {
	strcpy(mull, todos(mull));
	sprintf(s0, "%c-%ds", '%', x[au[i]]);
	sprintf(s, s0, mull);
	if (i != 0) {
	  fprintf(f, "%c %s ", 179, s);
	} else {
	  fprintf(f, "%s ", s);
	}
      }
      if (m == 2) {
	if (i == ((FeldNamen != NULL) ? FeldNamen->felds : 7)) {
	  fprintf(f, "        <th>%s</th>\n", mull);
	  fprintf(f, "      </tr>\n\n", mull);
	} else {
	  fprintf(f, "        <th>%s</th>\n", mull);
	}
      }
    }
  }
  if (m == 0) {
    fprintf(f, "\n");
  }
  if (m == 1) {
    fprintf(f, "%c%c%c%c<  %c%c", 186, 13, 10, 27, 204, 205);
  }
  /* Schreiben der Trennlinie */
  for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 7); i++) {
    if (x[au[i]] != -1) {
      if (m == 0) {
	drucken_a_lot_of(mull, x[au[i]], '-');
	if (i == 0) {
	  fprintf(f, "  %s", mull);
	} else {
	  fprintf(f, "-%s", mull);
	}
      }
      if (m == 1) {
	drucken_a_lot_of(mull, x[au[i]], 205);
	if (i != 0) {
	  fprintf(f, "%c%c%s%c", 216, 205, mull, 205);
	} else {
	  fprintf(f, "%s%c", mull, 205);
	}
      }
    }
  }
  if (m == 0) {
    fprintf(f, "\n");
  }
  if (m == 1) {
    fprintf(f, "%c%c%c", 185, 13, 10);
  }
  /* Schreiben der Datenstze */
  a = kette_first;
  do {
    if (m == 1) {
      fprintf(f, "%c<  %c ", 27, 186);
    }
    for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 7); i++) {
      if (x[au[i]] != -1) {
	strcpy(mull, GetDataFeld(a, au[i]));
	mull[x[au[i]]] = 0;
	if (m == 0) {
	  if (i == 0) {
	    fwrite(" ", 1, 1, f);
	  }
	  sprintf(s, " %c-%ds", '%', x[au[i]]);
	  fprintf(f, s, mull);
	}
	if (m == 1) {
	  strcpy(mull, todos(mull));
	  sprintf(s0, "%c-%ds", '%', x[au[i]]);
	  sprintf(s, s0, mull);
	  if (i != 0) {
	    fprintf(f, "%c %s ", 179, s);
	  } else {
	    fprintf(f, "%s ", s);
	  }
	}
	if (m == 2) {
	  if (i == 0) {
	    fprintf(f, "      <tr>\n", mull);
	  }
	  if (i == ((FeldNamen != NULL) ? FeldNamen->felds : 7)) {
	    fprintf(f, "        <td>%s</td>\n", mull);
	    fprintf(f, "      </tr>\n", mull);
	  } else {
	    fprintf(f, "        <td>%s</td>\n", mull);
	  }
	}
	if (i == (((FeldNamen != NULL) ? FeldNamen->felds : 7))) {
	  if (m == 1) {
	    fprintf(f, "%c%c%c", 186, 13, 10);
	  }
	  if (m == 0) {
	    fprintf(f, "\n");
	  }
	}
      }
    }
    a = a->next;
  } while (a != kette_first);
  /* Fuzeile, nur bei DOS-GRA */
  if (m == 1) {
    fprintf(f, "%c<  %c%c", 27, 200, 205);
    for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 7); i++)	{
      if (x[au[i]] != 0) {
	drucken_a_lot_of(mull, x[au[i]], 205);
	if (i != 0) {
	  fprintf(f, "%c%c%s%c", 207, 205, mull, 205);
	} else {
	  fprintf(f, "%s%c", mull, 205);
	}
      }
    }
    fprintf(f, "%c%c%c", 188, 13, 10);
  }
  if (m == 2) {
    fprintf(f, "    </table>\n  </body>\n</html>\n");
  }
  /* Schlien */
  fflush(f);
  fclose(f);
  /* Sichern der Druckerconfig */
  sprintf(mull, "%s.prn", datei);
  f = fopen(mull, "w");
  fwrite(&x, sizeof(x), 1, f);
  writeastring(f, wohin);
  fwrite(au, ((FeldNamen != NULL) ? FeldNamen->felds + 1 : 8), 1, f);
  fwrite(&m, 1, 1, f);
  fflush(f);
  fclose(f);
}



func()
{
  FILE *f;
  int i, i2;
  char mull[MULLLEN], cd[MULLLEN], tempeditstr[MULLLEN], command[MULLLEN];
  char b;

  f = fopen("/dev/urandom", "r");
  fread(&i2, 2, 1, f);
  fclose(f);  
  i = getch() - 48;
  if ((i > 8) || (i < 1)) return;
  if (datei == NULL) return;
  sprintf(mull, "%s.%d.rc", datei, i);
  f = fopen(mull, "r");
  mull[0] = 0;
  if (f != 0)
    {
      dosread(f, cd, MULLLEN);
      fclose(f);
      f = NULL;
      sprintf(mull, "xterm -e %s /tmp/.bdb.temp.%d", cd, i2);
      system(mull);
      eingabe(mull, "Laden und Einfgen der Daten? (y/n)",
	      "y", 1);
      if ((mull[0] == 'y') || (mull[0] == 'Y'))
	{
	  sprintf(mull, "/tmp/.bdb.temp.%d", i2);
	  f = fopen(mull, "r");
	  if (f == NULL)
	    {
	      eingabe(mull, "Can't read file!", mull, 0);
	      remove(mull);
	      return;
	    }
	  dosread(f, cd, MULLLEN);
	  fclose(f);
	  f = NULL;
	  b = i;
	  strcpy(tempeditstr, "\017\001");
	  for (i = 1; i <= 8; i++)
	    {
	      if (i == b)
		{
		  strcat(tempeditstr, cd);
		}
	      else
		{
		  strcat(tempeditstr, GetDataFeld(kette_akt, i - 1));
			 //			 (int)i);
		}
	      if (i == 8)
		{
		  sprintf(command, "%c%c", 11, 15);
		  strcat(tempeditstr, command);
		}
	      else
		{
		  sprintf(tempeditstr, "%s%c", tempeditstr, (char)(i + 1));
		}
	    }
	  if (0 != strcmp(kette_akt -> st, tempeditstr))
	    {
	      free(kette_akt->st);
	      kette_akt->st = (char*) malloc(strlen(tempeditstr) + 1);
	      pss(kette_akt->st);
	      strcpy(kette_akt->st, tempeditstr); 
	      status.ge = true;
	      status.ge_auto = true;
	    }
	  paint(1);
	}
      sprintf(mull, "/tmp/.bdb.temp.%d", i2);
      remove(mull);
    }
}


printakds()
{
  FILE *f;
  char cd0[50], cd1[50], cd2[50], cd3[50], cd4[50], b;
  int i;
  char mull[MULLLEN];

  sprintf(cd1, "%s/.stdprn.ahp", getenv("HOME"));
  if ((f = fopen(cd1, "r")) != NULL) {
    readastring(f, cd0); // Wohin die Ausgabe
    readastring(f, cd3); // DOS-Konvert?
  } else {
    cd0[0] = 0;
    cd3[0] = 0;
  }
  fclose(f);
  eingabe(cd2, "Do you want print this record? Pleace give the destination. (\".\" + ENTER = Cancel)", cd0, 1);
  if (cd2[strlen(cd2) - 1] == '.') {
    return;
  }
  eingabe(cd4, "Do you want convert the output to DOS-Font? (Y/N)", cd3, 1);

  if ((f = fopen(cd1, "w")) != NULL) {
    writeastring(f, cd2);
    writeastring(f, cd4);
    fflush(f);
    fclose(f);
  }

  if ((f = fopen(cd2, "w")) != NULL) {
    b = 0;
    if ((kette_akt != NULL) && (FeldNamen != 0) && (Name != NULL) && (f != NULL)) {
      for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 0); i++) {
	strcpy(cd2, GetDataFeld(FeldNamen, i));
	if ((int) strlen(cd2) >= b) {
	  b = strlen(cd2);
	}
      }
      if ((toupper(cd4[0]) == 'Y') || (toupper(cd4[0]) == 'J')) {
	fprintf(f, "Blacky Daten Bank: %s%c%c", todos(Name), 13, 10);
	for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 0); i++) {
	  if (kette_akt->st != NULL) {
	    strcpy(mull, GetDataFeld(kette_akt, i));
	    if (strlen(mull) > 0) {
	      
	      strcpy(mull, GetDataFeld(FeldNamen, i));
	      sprintf(cd2, "%s                                             ", mull);
	      fprintf(f, "  %.*s:", b, todos(cd2));
	      strcpy(mull, GetDataFeld(kette_akt, i));
	      fprintf(f, " %.*s%c%c", 60 - b, todos(mull), 13, 10);
	    }
	  }
	}
      } else {
	fprintf(f, "Blacky Daten Bank: %s\n", Name);
	for (i = 0; i <= ((FeldNamen != NULL) ? FeldNamen->felds : 0); i++) {
	  if (kette_akt->st != NULL) {
	    strcpy(mull, GetDataFeld(kette_akt, i));
	    if (strlen(mull) > 0) {
	      
	      strcpy(mull, GetDataFeld(FeldNamen, i));
	      sprintf(cd2, "%s                                             ", mull);
	      fprintf(f, "  %.*s:", b, cd2);
	      strcpy(mull, GetDataFeld(kette_akt, i));
	      fprintf(f, " %.*s\n", 60 - b, mull);
	    }
	  }
	}
      }
      /*      fflush(f);*/
      ffsync(f);
      fclose(f);
    }
  }  
}


wahl()
{
  int feld = 0, i;
  char mull[MULLLEN];
  FILE *f;
  char *command;

  for (i = 1; i <= 8; i++)
    {
      strcpy(mull, GetDataFeld( FeldNamen, i - 1));
      if (strncasecmp(mull, "tele", 4) == 0)
	{
	  feld = i;
	  break;
	}
    }
  if (feld == 0)
    {
      makeline(VLINE, NOMBG, VLINE, 1, 20);
      makeline(VLINE, NOMBG, VLINE, 1, 21);
      gotoxy(3, 20);
      addstr("Kein Feld fr Telefonnummer definirt! Feldname mu mit tele beginnen!");
      for (  ; !(i == 13 || i == 32); i = getch())
	;
      return;
    }
  command = (char *) getenv("BDB_MODEMWAHL_COMMAND");
  if (command != 0)
    {
      makeline(VLINE, NOMBG, VLINE, 1, 20);
      makeline(VLINE, NOMBG, VLINE, 1, 21);
      gotoxy(3, 20);
      addstr("Starte Commando fr den Modem-Gebrauch ... Bitte warten...");
      system(command);
      //      free(command);
    }
  f = fopen("/dev/blacky_modem", "w");
  if (f == NULL)
    {
      f = fopen("/dev/modem", "w");
      if (f == NULL)
	{
	  makeline(VLINE, NOMBG, VLINE, 1, 20);
	  makeline(VLINE, NOMBG, VLINE, 1, 21);
	  gotoxy(3, 20);
	  addstr("Konnte Modem (/dev/modem) nicht ffnen!");
	  for (  ; !(i == 13 || i == 32); i = getch())
	    ;
	  return;
	}
    }
  strcpy(mull, GetDataFeld(kette_akt, i - 1));
  for (i = 0; ((mull[i] != ' ') && (mull[i] != 0)); i++)
    ;
  mull[i] = 0;
  fprintf(f, "+++ATZ%c", 13);
  //  fprintf(f, "AT S7=45 S0=0 L1 V1 X4 &c1 E1 Q0%c\n", 13);
  fflush(f);
  /*  fscanf(f, "%s", mull);
  if (strncmp(mull, "OK", 2) != 0) {
    makeline(VLINE, NOMBG, VLINE, 1, 20);
    makeline(VLINE, NOMBG, VLINE, 1, 21);
    gotoxy(3, 20);
    addstr("ERROR (/dev/modem): ");
    addstr(mull);
    for (  ; !(i == 13 || i == 32); i = getch())
      ;
    return;
    }*/
  sleep(4);
  fprintf(f, "ATDT%s%c", mull, 13);
  fflush(f);
  /*  fclose(f);*/
  makeline(VLINE, NOMBG, VLINE, 1, 20);
  makeline(VLINE, NOMBG, VLINE, 1, 21);
  gotoxy(3, 20);
  addstr("Whle jetzt die Nummer... (Nehmen Sie den Hhrer ihres Telefons ab, warten");
  gotoxy(3, 21);
  addstr("Sie bis gewht wurde und drcken dann eine SPACE.");
  for (  ; !(i == 13 || i == 32); i = getch())
    ;
  /*  f = fopen("/dev/modem", "w");*/

  fprintf(f, "+++ATZ%c", 13);
  fflush(f);
  //  fprintf(f, "x\n");
  //  fflush(f);
  fclose(f);
  paint(1);
}


main(argc, argv)
  int argc;
  char *argv[];
{
  char command[MULLLEN];
  FILE *f;

  allblackyintro(blacky_ver_info);

  if ((argc > 1) ? ((argv[1][0] == '-') && ((argv[1][1] == '?') || (toupper(argv[1][1]) == 'H'))) : 0) {
    printf("Help:\n");
    printf("  l_bdb <<file> [-a] [-u] | <-v>>\n");
    printf("    -a: Save databank in old format\n");
    printf("    -u: Do not display infofile (for slowly computers)\n");
    printf("    -v: Version, Licenze\n");
    exit(0);
  }

  if ((argc > 2) ? ((argv[2][0] == '-') && (toupper(argv[2][1]) == 'A')) : 0) {
    wto = 1;
  }
  if ((argc > 2) ? ((argv[2][0] == '-') && (toupper(argv[2][1]) == 'U')) : 0) {
    zeigeinfo = 0;
  }
  if ((argc > 3) ? ((argv[3][0] == '-') && (toupper(argv[3][1]) == 'U')) : 0) {
    zeigeinfo = 0;
  }

  if ((argc == 2) ? ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'V')) : 0) {
    printf("%s\n\n", blacky_ver_info);
    printkinfo(stdout);
    exit(0);
  }

  /* Editor? */
  EDITOR = (char *) getenv("EDITOR");
  if (EDITOR == NULL) {
    EDITOR = (char *) malloc(3);
    if (EDITOR == NULL) {
      perror("malloc()");
      exit(1);
    }
    strcpy(EDITOR, "vi");
  }
  EDITOR2 = (char *) getenv("EDITOR2");
  if (EDITOR2 == NULL) {
    EDITOR2 = (char *) malloc(11);
    if (EDITOR2 == NULL) {
      perror("malloc()");
      exit(1);
    }
    strcpy(EDITOR2, "xemacs -nw");
  }
  VIEWER = (char *) getenv("VIEWER");
  if (VIEWER == NULL) {
    VIEWER = (char *) malloc(5);
    if (VIEWER == NULL) {
      perror("malloc()");
      exit(1);
    }
    strcpy(VIEWER, "less");
  }


  /* Write noticefiles to */
  blktxt = (char *) getenv("BLKTXT");
  if (blktxt == NULL) {
    char cd[255];

    sprintf(cd, "%s/txt", getenv("HOME"));
    blktxt = (char *) malloc(strlen(cd) + 1);
    if (blktxt == NULL)	{
      perror("malloc()");
      exit(1);
    }
    strcpy(blktxt, cd);
  }

  /* testwrite */
  {
    char cd[255];
    FILE *f;

    sprintf(cd, "%s/.testwrite", blktxt);
    if ((f = fopen(cd, "w+")) != NULL) {
      fclose(f);
      remove(cd);
    } else {
      char cd2[255];

      perror("fopen()");
      fprintf(stderr, "** WARNING: Can't write to %s\n", blktxt);
      sprintf(cd2, "mkdir -p %s", blktxt);
      fprintf(stderr, "Trying %s...\n", cd2);
      system(cd2);

      if ((f = fopen(cd, "w+")) != NULL) {
	fclose(f);
	remove(cd);
      } else {
	perror("fopen()");
	fprintf(stderr, "** ERROR: Can't create dir: %s\n", blktxt);
	fprintf(stderr, "** WARNING: Can't write to %s\n", blktxt);
      }

      fprintf(stderr, "Info-Files will be written to: %s\n", blktxt);
      fprintf(stderr, "You can change the directory with the enviroment\n" \
	      "variable BLKTXT.\n\nPress ENTER to continue...");

      getchar();

    }
  }


  init_cur_graph();

  /* Interrups vergeben ... */
  signal(SIGHUP, finish);       /* 01  /  hangup     - Alt-F4                            */
  signal(SIGINT, finish);       /* 02  /  Interrupt  - ^C                                */
  signal(SIGQUIT, finish);      /* 03  /  Quit                                           */
  signal(SIGTERM, finish);      /* 15  /  Terminierung                                   */
  /*     SIGALRM  */
  signal(SIGALRM, uhr);         /* 14  /  Alarm      - wenn gesetzte Zeit abgelaufen ist */
  /* Fenstergre gendert? */
  signal(SIGWINCH, winversch);  /* 28  /  ?          - grennderund des xTerms         */
  status.swhg = 0;
  kette_first = NULL;
  kette_last = NULL;
  kette_akt = NULL;
  akt = 1;
  FeldNamen = NULL;
  SuchStr = NULL;
  Name = NULL;
  status.sort = 0;
  status.ge = false;
  status.ge_auto = false;

  if (argc > 1) {
    /* Prfen, ob die Parameterdatei existiert */
    if ((f = fopen(argv[1], "r")) != NULL) {
      fclose(f);
      f = NULL;
      load(argv[1]);
    } else {
      /* Hate der User villeicht '.bdb' vergessen */ 
      strcpy(command, argv[1]);
      strcat(command, ".bdb");
      if ((f = fopen(command, "r")) != NULL) {
	fclose(f);
	f = NULL;
	load(command);
      } else {
	/* Oder '.BDB'? */
	strcpy(command, argv[1]);
	strcat(command, ".BDB");
	if ((f = fopen(command, "r")) != NULL) {
	  fclose(f);
	  f = NULL;
	  load(command);
	} else {
	  /*                     sprintf(command, "%cFehler beim laden der Datei : %s !\n", 0x7, argv[1]);
				 finish(-2);*/
	  eingabe(command, "Can not read file! Try create. (C-c (Ctrl+C) - Cancel)", "", 0);
	  if ((f = fopen(argv[1], "w")) == NULL) {
	    eingabe(command, "Con not create file!", "", 0);
	    finish(-2);
	  }
	  fclose(f);
	  makefnmask();
	  //	  datei = argv[1];
	  datei = (char *) malloc(strlen(argv[1]) + 2);
	  pss(datei);
	  strcpy(datei, argv[1]); 
	}
      }
    }
  } else {
    fprintf(stderr, "Help\n  D_BDB <datenbank>\n\n\nNeue Datenbank !");
  }

  check_backup_files();

  paint(0);
  /* ABSOLUTELY NO WARRANTY */
  gotoxy(3, 20);
  addstr("This is free software with ABSOLUTELY NO WARRANTY.");
  gotoxy(3, 21);
  addstr("For details read $HOME/.Blacky_NO_WARRANTY.");
  /* UHR */
  alarm(1);
  /* x-Term-Titel */
  blacky_xterm_set_titel("Blacky Daten Bank", datei);
  /* Hauptschleife */
  do
     {
       gotoxy(14, 23);
       switch (getch())
         {
	   //	 case 'v':
	 case 'V':
	   learn_vocable();
	   break;

	    /* Functionen ! - [1 - 8] */
	    case '!':
	      func();
	    break;

	    /* Feldnamen Editiren - 'F' || 'f' */ 
	    case 70:
	    case 102:
	      editfn();
	    break;

	    /* Datenbanknamen ndern - 'N' || 'n' */
	    case 78:
	      //	    case 110:
	      editdbname();
	    break;

            /* Sortierung festlegen - 'S' || 's' */
            case 115:
            case 83:
              setsort();
            break;

	    /* DS Editiren - 'ENTER' */
	    case 13:
	    case 343:
	      editds();
	    break;

	    /* exit - 'ESC' || 'ALT-X' */
	    case 27:
	    case 'x':
	    case 'X':
	    case 'q':
	    case 'Q':
	      exitbdb();
	    break;

	    /* DE PLUS 10% - 'PAGE UP' */
	    case 339:
	      dsptenp();
	    break;

	    /* DE MINUS 10% - 'PAGE DOWN' */
	    case 338:
	      dsmtenp();
	    break;

	    /* DE PLUS - 'UP' oder '+' */
	    case 259:
            case '+':
	      dsnext();
	    break;
	      
	    /* DS LAST - 'DN' oder '-' */
	    case 258:
            case '-':
	      dslast();
	    break;

	    /* new DS - 'INS' oder 'I' */
	    case 331:
	    case 'I':
	      dsnew();
	    break;

	    /* info (licenze) */
	 case 'i':
	   {
	     char file[] = "/tmp/.Blacky__NO_WARRANTY_and_Pinfo";
	     char ss[500];
	     FILE *f;

	     makeline(VLINE, NOMBG, VLINE, 1, 20);
	     makeline(VLINE, NOMBG, VLINE, 1, 21);
	     //	     gotoxy(3, 20);
	     //	     addstr("Lade Info-Datei, Bitte Warten...");

	     f = fopen(file, "w");
	     if (f == NULL) {
	       uhr(1);
	       break;
	     }
	     fprintf(f, "%s\n\n", blacky_ver_info);
	     printkinfo(f);
	     ffsync(f);
	     fclose(f);

	     sprintf(ss, "%s %s\n", EDITOR, file);

	     alarm(0);
	     endwin();
	     system(ss);
             remove(file);
	     alarm(1);
	     uhr(1);
	   }
	   break;

	    /* del DS - 'DEL' oder 'k' */
	    case 330:
            case 'k':
	    case 'K':
	      dskill();
	    break;

	    /* to first ds - 'HOME' */
	    /*  case 49:
		if (getchar() != 126)
		break; */
	    //	    case 72:
	    case 262:
	      dstohome();
	    break;

	    /* to last ds - 'END' */
	    /*	    case 70: */
	    case 360:
	      dstoend();
	    break;

	    /* HELP - F1 - h */
	    case 265:
            case 'h':
	    case 'H':
	      makeline(VLINE, NOMBG, VLINE, 1, 7);
	      makeline(VLINE, NOMBG, VLINE, 1, 8);
	      makeline(VLINE, NOMBG, VLINE, 1, 9);

	      gotoxy(3, 7);
	      addstr("x=Exit UP,DN=Select F2=Save F4=Save As /,n=Search ?=Edit Info");
	      gotoxy(3, 8);
	      addstr("N=Edit DB Name F=Edit Feld Names INS=New ENTER=Edit DEL=Erase");
	      gotoxy(3, 9);
	      addstr("S=Sort by D=Print P=Print DS Space=Redraw i=License Info");
	      
	      makeline(RABGE, HLINE, LABGE, 1, 10);

	      break;

	    /* Save - F2 oder 'w' */
	    case 266:
            case 'w':
	    case 'W':
	      save();
	      paint(1);
	    break;

	    /* Weitersuchen */
	    case 'r':
	    case 'R':
	    case 'n':
	      wsuchen();
	    break;
	      

	    /* Suchen - F3 oder '/' */
	    case 267:
            case '/':
	      suchen();
	    break;

	    /* Save As - F4 oder 'a' */
	    case 268:
            case 'a':
            case 'A':
	      saveas(); 
	    break;

	    /* Drucken = 'D' || 'd' */
	    case 100:
	    case 68:
	      drucken();
	    break;

	    /* Drucken des Acktuellen DS = 'p' || 'P' */
	    case 'p':
	    case 'P':
	      printakds();
	    break;

	    /* Redraw - Space */
	    case ' ':
            case 12:
	      endwin();
	      paint(1);
	    break;

	    case '?':
	      {
		int i;
		FILE *f;
		char cd[500];

		makeline(VLINE, NOMBG, VLINE, 1, 20);
		makeline(VLINE, NOMBG, VLINE, 1, 21);
		//		gotoxy(3, 20);
		//		addstr("Lade Info-Datei, Bitte Warten...");

		paint_info_get_feld();
		paint_info_get_filename(akt, kette_akt);

		if (zeigeinfo_filename != NULL) {
		  endwin();

		  alarm(0);
		  sprintf(cd, "%s %s", EDITOR, zeigeinfo_filename);
		  system(cd);

		  alarm(1);
		}
		paint(1);
	      }
	    break;

	    case '_':
	      {
		int i;
		FILE *f;
		char cd[500];

		makeline(VLINE, NOMBG, VLINE, 1, 20);
		makeline(VLINE, NOMBG, VLINE, 1, 21);
		//		gotoxy(3, 20);
		//		addstr("Lade Info-Datei, Bitte Warten...");

		paint_info_get_feld();
		paint_info_get_filename(akt, kette_akt);

		endwin();

		alarm(0);
		sprintf(cd, "%s %s", EDITOR2, zeigeinfo_filename);
		system(cd);
		alarm(1);
		paint(1);
	      }
	    break;

	    case 'v':
	      //	    case 'V':
	    case '=':
	      {
		int i;
		FILE *f;
		char cd[500];

		makeline(VLINE, NOMBG, VLINE, 1, 20);
		makeline(VLINE, NOMBG, VLINE, 1, 21);
		//		gotoxy(3, 20);
		//		addstr("Lade Info-Datei, Bitte Warten...");

		paint_info_get_feld();
		paint_info_get_filename(akt, kette_akt);

		endwin();

		alarm(0);
		sprintf(cd, "%s %s", VIEWER, zeigeinfo_filename);
		system(cd);
		alarm(1);
		paint(1);
	      }
	    break;



            case 261:
	      paint_info_newline();
	    break;

	    /* Via Modem Whlen (Funkttioniert nur bei Adressen) */
	    case 'C':
	    case 'c':
	      wahl();
	    break;	    

	    /* Wenn keine bekannte Taste gedrckt wurde */
	    default:
	      /*endwin();*/
	      paint(1);
	    break;

         } /* END CASE */     
   } while (1);

/*
  GoToXY(50, 5); (Bei 1 beginnend)
   X = von Rechtz
   Y = von Links

Alias to:

  move(o, l) :
   Bei NULL beginnend !!!
   o = von oben;
   l = von links;
*/
}


static void uhr(int sig)
{
  static long ti;
  static struct tm *tminfo;
  static char outstr[9];
  static int x, y;

  if (status.swhg) {
    return;
  }

  /* Ngster aufruf, nur von einem signal aufruf ! */
  if (sig != 128) {
    signal(SIGALRM, uhr);
    alarm(1);
  }
  getsyx(y, x);
  /* Get Time Date */
  ti = time(&ti);
  tminfo = localtime(&ti);
  sprintf(outstr, "%02d:%02d:%02d", tminfo -> tm_hour, tminfo -> tm_min, tminfo -> tm_sec);
  /* Ausgeben */
  gotoxy(65, display_first_data_feld_line - 1/*10*/);
  addstr(outstr);
  /*  gotoxy(14, 23); */
  setsyx(y, x);
  refresh();

  // Auto-Save, nur wenn gendert
  if (status.ge_auto) {
    // nur wenn mehr ale eine Minute vergangen
    if (status.last_auto != tminfo -> tm_min) {
      status.last_auto = tminfo -> tm_min;
      autosave();
    }
  }
}


static void winversch(int sig)
{
  signal(SIGWINCH, winversch);
  printf("%c", 7);
  endwin();
  paint(1);
}


check_backup_files()
{
  char cd[MULLLEN];
  int i;
  int mess = 0;

  endwin();
  alarm(0);
  endwin();
  
  sprintf(cd, "%s%s%c", getenv("HOME"), "/NAMENLOS.BDC", 0);
  if (filelen(cd) > 0) {
    fprintf(stderr, "%c** WARNING: Found: %s/NAMENLOS.BDC\n", 7, getenv("HOME"));
    mess = 1;
  }
  sprintf(cd, "%s%s%c", getenv("HOME"), "/NAMENLOS.LR", 0);
  if (filelen(cd) > 0) {
    fprintf(stderr, "%c** WARNING: Found: %s/NAMENLOS.LR\n", 7, getenv("HOME"));
    mess = 1;
  }
  strcpy(cd, "/tmp/NAMENLOS.BDB.LR");
  if (filelen(cd) > 0) {
    fprintf(stderr, "%c** WARNING: Found: /tmp/NAMENLOS.BDB.LR\n", 7);
    mess = 1;
  }
  strcpy(cd, "/tmp/namenlos.bda");
  if (filelen(cd) > 0) {
    fprintf(stderr, "%c** WARNING: Found: /tmp/namenlos.bda\n", 7);
    mess = 1;
  }

  if (datei != NULL) {
    strcpy(cd, datei);
    i = strlen(datei) - 1;
    cd[i] = cd[i] + 1;
    if (filelen(cd) > 0) {
      fprintf(stderr, "%c** WARNING: Found: %s\n", 7, cd);
      mess = 1;
    }
    cd[i] = cd[i] - 2;
    if (filelen(cd) > 0) {
      fprintf(stderr, "%c** WARNING: Found: %s\n", 7, cd);
      mess = 1;
    }
  }

  if (mess) {
    fprintf(stderr, "This file is a emergency save that accrues if l_bdb can't\n" \
	    "save the orginal file or l_bdb crash.\n" \
	    "You can open this file with l_bdb <file>.\n" \
	    "If this file newer or better as the orginal db move the file.\n" \
	    "If not erase the file to avoid this message.\n\n"\
	    "Press ENTER...\n");

    fflush(stderr);

    //  getch();
    scanf("%c", &mess);
  }

  
}


static void finish(int sig)
{
  char cd[MULLLEN];

  status.swhg = 1;
  exitsave = 1;

  endwin();

  learn_vocable_write_db();

  //  check_backup_files();

  /* Spichern Befor beenden, wenn gendert */
  if (status.ge) {
    /* Dateinamen ndert, um zu verhindern, das die alte Datei
       berschrieben wird */
    if (datei == NULL) {
      sprintf(cd, "%s%s%c", getenv("HOME"), "/NAMENLOS.BDC", 0);
      datei = (char *) malloc(strlen(cd) + 2);
      strcpy(datei, cd);
    } else {
      datei[strlen(datei) - 1] = datei[strlen(datei) - 1] + 1;
    }
    fprintf(stderr, "%c** WARNING: emergency save to: %s\n", 7, datei);
    save();
  }
  /* Letzte Rettung, wenn's nicht geklapt hat werden die Daten ins Home
     geschrieben */
  if (status.ge) {
    sprintf(cd, "%s%s%c", getenv("HOME"), "/NAMENLOS.LR", 0);
    datei = (char *) malloc(strlen(cd) + 2);
    strcpy(datei, cd);
    save();
    fprintf(stderr, "%c** WARNING: emergency save to: %s\n", 7, datei);
    if (status.ge) {
      datei = (char *) malloc(22);
      strcpy(datei, "/tmp/NAMENLOS.BDB.LR");
      save();
      fprintf(stderr, "%c** WARNING: emergency save to: %s\n", 7, datei);
    }
  }
  /* Herrunterfahren */
  endwin();
  /* x-Term-Titel */
  blacky_xterm_set_titel("xterm", 0L);
  /* Error - Rckgabe */
  //  printf("Blacky Daten Bank wurde Herruntergefahren (%d)...\n", sig);
  if (sig < 0) {
    if (sig == -1)
      fprintf(stderr, "** FEHLER ** : Nicht gengent Speicher!\n");
    if (sig == -2)
      fprintf(stderr, "** FEHLER ** beim ffnen der Datei!\n");
    exit(1);
  }
  exit(0);
}


struct adr *return_point_of_data_by_index(int index)
{
  struct adr *a;

  a = kette_first;

  for (  ; index > 1; index--) {
    a = a->next;
  }
  return a;
}

// Fragt Vocabeln ab...
learn_vocable()
{
  int i, i2, point, versuch, old_akt = akt, to0;
  char cd[256];
  struct adr *a, *kette_akt_old = kette_akt;
  int linear = 0;

  if ((kette_first == NULL) || (FeldNamen == NULL) || (FeldNamen->st == NULL)) {
    return;
  }

  // INIT RANDOM
  if (1) {
    FILE *urandom;
    unsigned int seed;

    if ((urandom = fopen("/dev/urandom", "r")) != NULL) {
      fread(&seed, 1, sizeof(int), urandom);
      srand(seed);
      fclose(urandom);
    }
  }

  learn_vocable_alloc_db();

  makeline(RABGE, HLINE, LABGE, 1, 10);
  makeline(VLINE, NOMBG, VLINE, 1, 11);
  makeline(VLINE, NOMBG, VLINE, 1, 12);
  makeline(VLINE, NOMBG, VLINE, 1, 13);
  makeline(VLINE, NOMBG, VLINE, 1, 14);
  makeline(VLINE, NOMBG, VLINE, 1, 15);
  makeline(VLINE, NOMBG, VLINE, 1, 16);
  makeline(VLINE, NOMBG, VLINE, 1, 17);
  makeline(VLINE, NOMBG, VLINE, 1, 18);
  makeline(RABGE, HLINE, LABGE, 1, 19);
  makeline(VLINE, NOMBG, VLINE, 1, 20);
  makeline(VLINE, NOMBG, VLINE, 1, 21);
  makeline(VLINE, NOMBG, VLINE, 1, 22);
  makeline(VLINE, NOMBG, VLINE, 1, 23);
  makeline(LUECK, HLINE, RUECK, 1, 24);

  while (1) {
    // !ACHTUNG! : AKT zurcksetzten!
    if (linear) {
      akt++;
      if (akt > ges) {
	linear = 0;
	//	akt = 1;
      }
    VOC_ANF:
      point = akt;
    } else {
      akt = point = learn_vocable_get_nummer();
    }
    kette_akt = a = return_point_of_data_by_index(point);

    makeline(VLINE, NOMBG, VLINE, 1, 11);
    makeline(VLINE, NOMBG, VLINE, 1, 12);
    makeline(VLINE, NOMBG, VLINE, 1, 13);

    makeline(VLINE, NOMBG, VLINE, 1, 20);
    makeline(VLINE, NOMBG, VLINE, 1, 21);

    /*****/
    makeline(RABGE, HLINE, LABGE, 1, 19);
    // Position
    gotoxy(9, 19);
    sprintf(cd, "[%02d%%]", (int) ((double) (100) /*8*/ * ((double) (akt - 1) / (double) (ges))));
    addstr(cd);
    // Nummer des Aktuellen DS / Von insgesammt DS
    gotoxy(65, 19);
    sprintf(cd, "%d/%d", akt, ges);
    addstr(cd);
    /*****/

    i2 = 1;
    for (i = 0; i <= 1; i++) {
      gotoxy(3, i2 + 10);
      sprintf(cd, "%s                                             ", GetDataFeld(FeldNamen, i));
      //      sprintf(cd, "%.*s :", maxdfbez, GetDataFeld(FeldNamen, i));
      cd[maxdfbez + 1] = ':';
      cd[maxdfbez + 2] = 0;
      addstr(cd);
      i2++;
    }
    
    gotoxy(maxdfbez + 6, 11);
    sprintf(cd, "%.*s", 60 - maxdfbez, GetDataFeld(a, 0));
    addstr(cd);
    sprintf(cd, "%.*s", 60 - maxdfbez, GetDataFeld(a, 1));

    to0 = 0;
    if (strncasecmp("to ", cd, 3) == 0) {
      to0 = 3;
    }
    i = strlen(cd + to0) - 2;
    if (i < 5) {
      i++;
    }
    for (; i > 0; i--) {
      if ((cd[i + to0] != '\'') && (cd[i + to0] != '(') && (cd[i + to0] != ')') && (cd[i + to0] != '-') && (cd[i + to0] != ' ') && (cd[i + to0] != ',') && (cd[i + to0] != '.')) {
	cd[i + to0] = '?';
      }
    }
    gotoxy(maxdfbez + 6, 12);
    addstr(cd /*"?"*/); 

    cd[0] = 0;
    versuch = 0;
    // Solange Vakable falsch ist
    while (strcmp(GetDataFeld(a, 1), cd) != 0) {

      gotoxy(30, 19);
      sprintf(cd, "R:%02d W:%02d I:%02d", learn_vocable_db[(akt - 1) * 3 + 0], learn_vocable_db[(akt - 1) * 3 + 1], learn_vocable_db[(akt - 1) * 3 + 2]);
      addstr(cd);

      eingabe(cd, "ENTER the right vocable:", "", 0);
      if (strncmp(cd, "LINEAR", 6) == 0) {
	linear = 1;
	if (cd[6] == ' ') {
	  akt = atoi(cd + 7);
	} else {
	  akt = 1;
	}
	goto VOC_ANF;
      }
      if (strcmp(cd, "EXIT") == 0) {
	akt = old_akt;
	kette_akt = kette_akt_old;
	return;
      }
      versuch++;

      // SCHEIE...
      if (1) {
	char cd[256];

	makeline(VLINE, NOMBG, VLINE, 1, 11);
	makeline(VLINE, NOMBG, VLINE, 1, 12);
	makeline(VLINE, NOMBG, VLINE, 1, 13);
      
	makeline(VLINE, NOMBG, VLINE, 1, 20);
	makeline(VLINE, NOMBG, VLINE, 1, 21);

	i2 = 1;
	for (i = 0; i <= 1; i++) {
	  gotoxy(3, i2 + 10);
	  sprintf(cd, "%s                                             ", GetDataFeld(FeldNamen, i));
	  //      sprintf(cd, "%.*s :", maxdfbez, GetDataFeld(FeldNamen, i));
	  cd[maxdfbez + 1] = ':';
	  cd[maxdfbez + 2] = 0;
	  addstr(cd);
	  i2++;
	}
      
	gotoxy(maxdfbez + 6, 11);
	sprintf(cd, "%.*s", 60 - maxdfbez, GetDataFeld(a, 0));
	addstr(cd);
	

	gotoxy(maxdfbez + 6, 12);
	addstr(GetDataFeld(a, 1));
      }
      gotoxy(maxdfbez + 6, 13);
      addstr(cd);

      gotoxy(maxdfbez + 6, 14);
      addstr("Enter EXIT to exit...");
    }
    if (versuch == 1) {
      learn_vocable_set_nummer(point, 1);
    } else {
      learn_vocable_set_nummer(point, 0);
    }
  }
}

/* In der learn_vocable_db wird gespeichert, wie offt ein vocable
   Falsch, Richtig eingegeben wurde, und wie offt es daraus
   resutierent Ingnoriert, sprich nicht mehr abgefragt werden soll. */

/* Trgt ein ob ein Vocable Falsch oder Richtig eingegeben wurde und
   errechnet die Ignorieren Zahl */
learn_vocable_set_nummer(int akt, int right)
{
  if (right == 1) {
    learn_vocable_db[(akt - 1) * 3 + 0]++;
    learn_vocable_db[(akt - 1) * 3 + 2] += learn_vocable_db[(akt - 1) * 3 + 0] * 10;
  } else {
    learn_vocable_db[(akt - 1) * 3 + 1]++;
    learn_vocable_db[(akt - 1) * 3 + 2] = 0;
  }
}

/* Gibt zufllig eine Index-Nummer eines Vocables unter
   Brcksichtigung der learn_vocable_db aus */
int learn_vocable_get_nummer()
{
  int i;

  do {
    i = 1 + (int) ((double) ((double) ges * (double) rand() / (double) ((double) RAND_MAX + (double) 1.0 )));
    if (learn_vocable_db[(i - 1) * 3 + 2] > 0) {
      learn_vocable_db[(i - 1) * 3 + 2]--;
    }
  } while (learn_vocable_db[(i - 1) * 3 + 2] != 0);
  return i;
}

/* Belegt den Speicher fr die learn_vocable_db. In Abhngigkeit von
   der Anzahl der Vocabeln: X = 3*ANZ-Voc. */
learn_vocable_alloc_db()
{
  if ((learn_vocable_db = (unsigned char *) malloc(ges * 3)) == NULL) {
    return;
  }
  bzero(learn_vocable_db, ges * 3);
  learn_vocable_read_db();
}

/* Ld die learn_vocable_db aus der Datei. <dateiname>.lvdb */
learn_vocable_read_db()
{
  FILE *f;
  char filename[255];


  if (learn_vocable_db == NULL) {
    return;
  }
  sprintf(filename, "%s.lvbd", datei);
  if ((f = fopen(filename, "r")) != NULL) {
    fread(learn_vocable_db, ges * 3, 1, f);
    fclose(f);
  }
}

/* Schreibt die learn_vocable_db in die Datei <dateiname>.lvdb */
learn_vocable_write_db()
{
  FILE *f;
  char filename[255];


  if (learn_vocable_db == NULL) {
    return;
  }
  sprintf(filename, "%s.lvbd", datei);
  if ((f = fopen(filename, "w")) != NULL) {
    fwrite(learn_vocable_db, ges * 3, 1, f);
    ffsync(f);
    fclose(f);
  }
}
