/*
    l_bdb (Blacky Daten Bank fr Linux)

    Dies ist ein einfaches Datenbanksystem fr die Console.

    Copyright (C) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/


*/


#include <curses.h>
#include <signal.h>
#include <stdio.h>
#include <unistd.h>
#include <time.h>
#include "hofmeier.h"

char *EDITOR;
char *EDITOR2;

char blacky_ver_info[] = "Blacky Daten Bank v0.82 (c) Copyright 1996-2001 Andreas Hofmeier";


static char *eingabe();
/*static void editstr();*/



struct xstatus {
  unsigned ge : 1;
  unsigned sort : 3;
  unsigned swhg : 1;
};

struct adr     {
  char *st;
  struct adr *next;
  struct adr *last;
};


/* function zum Herunterfahren ! */
static void finish(int sig);
/* UHR function */
static void uhr(int sig);
/* Windowsgre gendert */
static void winversch(int sig);

/* Trennziechen */
unsigned char trz = 0;
/* Im alten Format Schreiben */
char wto = 0;
char frei[5] = "Frei";
char EDD[4] =  {16, 15, 17, 0};/*= "\020\017\021"; */
char BDB1[21] = "Blacky-Daten-Bank-1";
struct xstatus status;         /* Status {gendert? : Sort nach? : System wird Heruntergefahren } */
struct adr *kette_first;       /* Pionter auf das erste Glied in der Kette des DSs */
struct adr *kette_last;        /* Pionter auf das letzte Glied in der Kette des DSs */
struct adr *kette_akt;         /* Pionter auf das acktuelle Glied in der Kette des DSs */
char *Name;                    /* Name der Datenbank */
char *FeldNamen;               /* Feldnamen-Strucktur */
char *datei;                   /* Dateiname */
char *SuchStr;                 /* Letzter eingegebener Such-String */
unsigned char maxdfbez = 0;    /* Maximale Lnge der Feldname. Um die ":" richtig zu setzen */
int akt = 0;                   /* Acktueller DS */
int ges = 0;                   /* Gesammtzahl der DS */
char *runcommand = NULL;       /* Ausfhren eines Commandos sollte ber diese Variable gehen, da sonst die UHR dazwischenfunft! */
char zeigeinfo = 1;            /* Soll die Info-Datei zu den Datenstzen angezeigt werden? */
char zeigeinfo_nachname = 0;   /* Feld im der der Nachname Steht */
char zeigeinfo_vorname = 0;    /* Feld im dem der Voranme steht */
char *zeigeinfo_filename = NULL;/*Dateinamen fr Info-Datei*/
int zeigeinfo_filename_pos = 0;/* Fr welche Possition ist der Dateiname */
int zeigeinfo_file_line = 0;   /* In welcher Zeile ist das Programm gerade? */
FILE *zeigeinfo_file = NULL;   /* File-Discriptor fr ZeigeInfo newLine */




/* Lnge der normalen "Mll-Arrays" */
#define MULLLEN /*512*/ 256


pss(s, s2)
  char *s, s2[];
{
  if (s == NULL)
    finish(-1);
}


struct adr *newadr(st)
  char st[];
{
  struct adr *new, *a;
  int i, newakt = 0;
  char c[MULLLEN], mull[MULLLEN];

  /* knoten erzeugen und string einfgen. */
  new = (struct adr*) malloc(sizeof(struct adr));
  if (new == NULL)
     {
       finish(-1);
     }
  new->st = (char*) malloc(strlen(st) + 1);
  pss(new->st, st);
  strcpy(new->st, st);
 
  /* knoten in die kette einfuegen */
  if (kette_first == NULL)
     {
       /* neue kette */
       ges = 1;
       kette_first = new;
       kette_last = new;
       kette_akt = new;
       new->last = new;
       new->next = new;
     }
  else
    {
      a = kette_first;
      GetDatenSatz(c, new->st, status.sort + 1);
      do
         {
	   newakt++;
	   GetDatenSatz(mull, a->st, status.sort + 1);
	   i = strcasecmp(c, mull);
	   if (i == 0)
	     {
	       i = strcasecmp(new->st, a->st);
	     }

	   /* !!!! Wenn Datensatz identisch, nicht mehr hinzufgen !!!! */
	   if (i == 0)
	     return;

           if (i <= 0)
	     {
	       akt = newakt;
	       ges++;
	       /* printf("<%s> Hinter <%s> setzen 1...\n", c, mull); */
               if (a == kette_first)
                 kette_first = new;
	       (a->last)->next = new;
               new->last = a->last;
               a->last = new;
               new->next = a;
               
	       return new;
	     }
	   a = a->next;
           
	 }
           while (a != kette_first);
      /* hinten anhngen */
      akt = ++ges;
      kette_first->last = new;
      kette_last->next = new;
      new->last = kette_last;
      new->next = kette_first;
      kette_last = new;
    }
  /* Pointer auf neuen knoten zur/ckgeben */
  return new;
}


load(ldatei)
  char ldatei[];
{
  char Result;
  FILE *f;
  char c[2];
  char cd[MULLLEN], mull[MULLLEN];
  int i;
  
  blacky_status_error = 0;
  Result = true;
  if (ldatei == NULL)
     {
       Result = false;
       return Result;
     }
  f = fopen(ldatei, "r");
  if (f != 0)
     {
       /* Kopfzeile, Dateikennung */
       dosread(f, cd);
       trz = bdb_head(cd);
       if (trz != 0)
          {
            /* Name */
            dosread(f, mull);
	    if (mull[0] != 0)
	      {
		Name = (char *) malloc(strlen(mull) + 1);
		pss(Name, mull);
		strcpy(Name, mull);
	      }
            /* Feldnamen */
            dosread(f, mull);
	    bdb_conv(mull, 0, trz);
	    i = strlen(mull) - 1;
            if ((mull[i] < 14) || (mull[i] > 15))
	      {
                c[0] = mull[strlen(mull) - 1];
		c[1] = 0;
		i = atoi(c);
                if (i < 9 && i > 0)
		  status.sort = i - 1;
                mull[strlen(mull) - 1] = 0;
	      }
            FeldNamen = (char *) malloc(strlen(mull) + 1);
	    pss(FeldNamen, mull);
            strcpy(FeldNamen, mull);
	    maxdfbez = 0;
            /* Datensatze */
            do
               {
                 dosread(f, mull);
		 bdb_conv(mull, 0, trz);
                 if (((int) strpos(mull, EDD, 1) == (int) -1) && (mull[0] != 0))
                    {
                      newadr(mull);
                    }
                 else
                    {
                      break;
                    }
               }
                 while (1);
            /* Dateiname */
            datei = (char *) malloc(strlen(ldatei) + 1);
	    pss(datei, ldatei);
            strcpy(datei, ldatei); 
          }
       else
          {
	    printf("%c%c", 7, 7);
            eingabe(mull, "Dies ist keine Blacky-Daten-Bank, oder Lesefehler", "", 0);
          }
     }
  else
     {
       printf("%c%c", 7, 7);
       eingabe(mull, "Beim ffnen der Datei ist ein Fehler aufgetreten!", "", 0);
     }
  fclose(f);
  if (blacky_status_error != 0)
    {
      printf("%c%c", 7, 7);
      eingabe(mull, "Beim Lesen aus der Datei ist ein Fehler aufgetreten!", "", 0);
    }
  return Result;
}


makefnmask()
{
  if (FeldNamen == 0)
     {
       FeldNamen = (char *) malloc(13);
       sprintf(FeldNamen, "%c%c%c%c%c%c%c%c%c%c%c1",
	      14, 1, 2, 3, 4, 5, 6, 7, 8, 11, 14);
     }
}


save()
{
  FILE *f;
  char cd[MULLLEN];
  struct adr *a;

  /* Wenn kein Dateiname, Speichern unter */
  blacky_status_error = 0;
  if (datei == NULL)
    {
      saveas();
      return;
    }
  /* Dafr sorgen, dass Feldnamen verhanden sind */
  makefnmask();
  /* BackUp von der Datei */
  bsk(datei);
  /* Speichern... */
  f = fopen(datei, "w");
  if (f == NULL)
    {
      sprintf(cd, "%cDie Datei %s konnte nicht erzeugt werden!", 7, datei);
      eingabe(cd, cd, "", 0);
    }
  /* Dateikennung */
  if ((trz == 0) || (wto == 1) /* || (trz == '|')*/)
    {
      doswrite(f, BDB1);
    }
  else
    {
      sprintf(cd, "%s%c", BDB1, trz);
      doswrite(f, cd);
    }
  /* Schreibt Name und Feldnamen */
  if (Name != NULL)
    doswrite(f, Name);
  else
    doswrite(f, "");
  sprintf(cd, "%s%d", FeldNamen, status.sort + 1);
  if (wto == 0)
    {
      bdb_conv(cd, 1, trz);
    }
  doswrite(f, cd);
  /* Schreiben der Datenstze */
  if (kette_first != NULL)
    {
      a = kette_first;
      do
	{
	  if (wto == 1)
	    {
	      doswrite(f, a->st);
	    }
	  else
	    {
	      strcpy(cd, a->st);
	      bdb_conv(cd, 1, trz);
	      doswrite(f, cd);
	    }
	  a = a->next;
	}
      while (a != kette_first);
    }
  if (wto == 1)
    {
      doswrite(f, EDD);
    }
  else
    {
      doswrite(f, "");
    }
  /*fflush(f);*/
  /*fsync(fileno(f));*/ /* Physikalisches schreiben der Datei auf der Platte */
  ffsync(f);
  fclose(f);
  /* Physikalisches schreiben auf der Platte */
  /*  sync();*/

  /* Fehler Aufgetreten? */
  if (blacky_status_error != 0)
    {
      printf("%c", 7);
      makeline(VLINE, NOMBG, VLINE, 1, 20);
      makeline(VLINE, NOMBG, VLINE, 1, 21);
      gotoxy(3, 20);
      addstr("Beim Schreiben in der Datei ist ein Fehler Aufgetreten!");
    }
  else
    status.ge = false;
}


/* mod = 0: Mormal
       = 1: Mit ZeigeInfo */
paint(mod)
  char mod;
{
  int i;
  char s[MULLLEN], mull[MULLLEN];

  if (status.swhg)
    return;
  /*system("echo P0 > foo");*/
  echo();
  /*sprintf(s, "echo P0,5 \'%s\' >> foo", FeldNamen);
system(s);*/
  if ((maxdfbez == 0) && (FeldNamen != NULL))
    {
      for (i = 1; i <= 8; i++)
	{
	  strcpy(s, GetDatenSatz(mull, FeldNamen, i));
	  s[MULLLEN - 2] = strlen(s);
	  if (s[MULLLEN - 2] >= maxdfbez)
	    maxdfbez = s[MULLLEN - 2];
	}
    }
  /*system("echo P1 >> foo");*/
  if (maxdfbez > 25) maxdfbez = 25;
  makeline(LOECK, HLINE, ROECK, 1, 1);
  makeline(VLINE, NOMBG, VLINE, 1, 2);
  gotoxy(3, 2);
  /*  addstr("Blacky Daten Bank (c) Copyright by Andreas Hofmeier Computer Programme");*/
  addstr(blacky_ver_info);
  makeline(RABGE, HLINE, LABGE, 1, 3);
  makeline(VLINE, NOMBG, VLINE, 1, 4);
  gotoxy(3, 4);
  addstr("Datenbank:");
  makeline(VLINE, NOMBG, VLINE, 1, 5);
  gotoxy(3, 5);
  addstr("Name     :");
  makeline(RABGE, HLINE, LABGE, 1, 6);
  makeline(VLINE, NOMBG, VLINE, 1, 7);
  gotoxy(3, 7);
  addstr("ESC=Exit UP,DN=DS Auwahl F2=Save F4=Save_As F3=Suche C=Modemwahl ?=Info");
  makeline(VLINE, NOMBG, VLINE, 1, 8);
  gotoxy(3, 8);
  addstr("N=Name F=Feldnamen_E INS=Neu ENTER=Edit DEL=Lschen i=L-Info");
  makeline(VLINE, NOMBG, VLINE, 1, 9);
  gotoxy(3, 9);
  addstr("S=Sort D=Drucken P=Drucken_des_Acktuellen_DS Space=Redraw");
  makeline(RABGE, HLINE, LABGE, 1, 10);
  makeline(VLINE, NOMBG, VLINE, 1, 11);
  makeline(VLINE, NOMBG, VLINE, 1, 12);
  makeline(VLINE, NOMBG, VLINE, 1, 13);
  makeline(VLINE, NOMBG, VLINE, 1, 14);
  makeline(VLINE, NOMBG, VLINE, 1, 15);
  makeline(VLINE, NOMBG, VLINE, 1, 16);
  makeline(VLINE, NOMBG, VLINE, 1, 17);
  makeline(VLINE, NOMBG, VLINE, 1, 18);
  makeline(RABGE, HLINE, LABGE, 1, 19);
  makeline(VLINE, NOMBG, VLINE, 1, 20);
  makeline(VLINE, NOMBG, VLINE, 1, 21);
  makeline(RABGE, HLINE, LABGE, 1, 22);
  makeline(VLINE, NOMBG, VLINE, 1, 23);
  gotoxy(3, 23);
  addstr("COMMAND =>");
  makeline(LUECK, HLINE, RUECK, 1, 24);
  /* Feldnamen */
  if (FeldNamen != NULL)
    {
      for (i = 1; i <= 8; i++)
	{
	  gotoxy(3, i + 10);
	  sprintf(s, "%s                                             ", 
		  GetDatenSatz(mull, FeldNamen, i));
	  sprintf(mull, "%.*s :", maxdfbez, s);
          addstr(mull);
	}
    }

  if (kette_first != NULL)
    {
      for (i = 1; i <= 8; i++)
	{
	  gotoxy(maxdfbez + 6, i + 10);
	  sprintf(mull, "%.*s", 60 - maxdfbez, GetDatenSatz(mull, kette_akt->st, i));
	  addstr(mull);
	}
    }

  if (datei != NULL)
    {
      gotoxy(14, 4);
      addstr(datei);
    }
  if (Name != NULL)
    {
      gotoxy(14, 5);
      addstr(Name);
    }
  if (status.ge)
     {
       gotoxy(3, 19);
       addstr("*");
     }
  gotoxy(5, 19);
  sprintf(mull, "(%d)", status.sort + 1);
  addstr(mull);
  if (kette_akt != NULL)
    {
      if (kette_akt == kette_last)
	{
	  gotoxy(9, 19);
	  addstr("[END]");
	  akt = ges;
	}
      if (kette_akt == kette_first)
	{
	  gotoxy(9, 19);
	  addstr("[HOME]");
	  akt = 1;
	}
    }
  else
    {
      gotoxy(9, 19);
      addstr("[NONE]");
    }
  /* goto(von links, von oben);
     beginnend bei 1;          */
  gotoxy(65, 19);
  sprintf(mull, "?%d/%d", akt, ges);
  addstr(mull);

  /* Scroll Bar */
  i = (int) ((double) 8 * ((double) (akt - 1) / (double) (ges)));
  gotoxy(1, i + 11);
  addstr("#");

  noecho();
  /* Aufruf der UHR-Function */
  uhr(128);
  /*  
      Knnen raus, das uhr das bernimmt !
      gotoxy(14, 23); 
      refresh();
  */
  if ((zeigeinfo == 1) && (mod == 1))
    {
      paint_info();
    }
  refresh(); 
}


paint_info_get_feld()
{
  char s[200];
  int i;

  if ((zeigeinfo_nachname != 0) || (zeigeinfo_vorname != 0))
    {
      return;
    }
  if (kette_last == NULL)
     return;
  
  /*  if (kette_akt->st == NULL)
    {
      return;
      }*/
  for (i = 1; i <= 8; i++)
    {
      GetDatenSatz(s, FeldNamen, i);
      if ((strcasecmp(s, "name") == 0) || (strcasecmp(s, "nachname") == 0) || (strcasecmp(s, "lastname") == 0))
	{
	  zeigeinfo_nachname = i;
	  break;
	}
    }
  for (i = 1; i <= 8; i++)
    {
      GetDatenSatz(s, FeldNamen, i);
      if ((strcasecmp(s, "vorname") == 0) || (strcasecmp(s, "firstname") == 0))
	{
	  zeigeinfo_vorname = i;
	  break;
	}
    }
}


paint_info_get_filename(int akt, struct adr *kette_akt)
{
  int i;
  char s0[200], s1[200], s2[400];

  
  if (zeigeinfo_filename_pos == akt) {
    return;
  }
  if (kette_last == NULL) {
    return;
  }
  if (kette_akt->st == NULL) {
    return;
  }
  if ((zeigeinfo_nachname == 0) || (zeigeinfo_vorname == 0)) {
    return;
  }
  GetDatenSatz(s0, kette_akt->st, zeigeinfo_nachname);
  GetDatenSatz(s1, kette_akt->st, zeigeinfo_vorname);
  sprintf(s2, "%s/txt/pb.%s.%s.txt", getenv("HOME"), s1, s0);
  for (i = 0; s2[i] != 0; i++) {
    if (s2[i] == ' ' || (s2[i] == '(') || (s2[i] == ')') || (s2[i] == '\'') || (s2[i] == '\"'))	{
      s2[i] = '_';
    }
  }
  free(zeigeinfo_filename);
  zeigeinfo_filename = (char *) malloc(strlen(s2) + 1);
  if (zeigeinfo_filename != NULL) {
    strcpy(zeigeinfo_filename, s2);
  }
  zeigeinfo_filename_pos = akt;
}


paint_info()
{
  FILE *f;
  char s[400];

  paint_info_get_feld();
  paint_info_get_filename(akt, kette_akt);

  f = fopen(zeigeinfo_filename, "r");
  if (f == NULL)
    {
      return;
    }
  dosread(f, s);
  gotoxy(3, 20);
  addstr(s);
  dosread(f, s);
  gotoxy(3, 21);
  addstr(s);

  fclose(f);
  if (zeigeinfo_file_line != 0)
    {
      zeigeinfo_file_line = 0;
      if (zeigeinfo_file != NULL)
	{
	  fclose(zeigeinfo_file);
	}
    }
}


paint_info_newline()
{
  char s[300];

  if (zeigeinfo_file_line == 0)
    {
      paint_info_get_feld();
      paint_info_get_filename(akt, kette_akt);

      zeigeinfo_file = fopen(zeigeinfo_filename, "r");
    }
  if (zeigeinfo_file == NULL)
    {
      return;
    }

  if (feof(zeigeinfo_file) != 0)
    {
      return;
    }

  makeline(VLINE, NOMBG, VLINE, 1, 20);
  makeline(VLINE, NOMBG, VLINE, 1, 21);

  if (zeigeinfo_file_line == 0)
    {
      dosread(zeigeinfo_file, s);
      dosread(zeigeinfo_file, s);
    }

  dosread(zeigeinfo_file, s);
  gotoxy(3, 20);
  addstr(s);
  dosread(zeigeinfo_file, s);
  gotoxy(3, 21);
  addstr(s);

  zeigeinfo_file_line += 2;
}


static char *eingabe(result, was, def, al)
  char *result;
  char was[];
  char def[];
  int al;
{
  char i;

  makeline(VLINE, NOMBG, VLINE, 1, 20);
  makeline(VLINE, NOMBG, VLINE, 1, 21);

  echo();
  gotoxy(3, 20);
#ifdef BLACKY_cur_Graphik
  attrset(A_STANDOUT);
#endif
  addstr(was);
#ifdef BLACKY_cur_Graphik
  attrset(A_NORMAL);
#endif
  if ((def[0] == 0) && (!((def[0] == ' ') && (def[1] == 0))))
    {
      gotoxy(3, 21);
      refresh(); 
      result[0] = 0;
      editstr(result, 20, 2, al);
    }
  else
    {
      result[0] = 0;
      result[1] = 0;
      if (!((def[0] == ' ') && (def[1] == 0)))
	strcpy(result, def);
      editstr(result, 20, 2, al);
    }
  paint(1);
  noecho();
  return result;
}


// berprft, ob der zu Suchende String in der zum DatanSatz gehrigen
// Datei vorhanden ist
ifstringineds(int newakt, struct adr *a) {
  FILE *f;
  char s[400];
  char mull[400];

  paint_info_get_feld();
  zeigeinfo_filename_pos = 0;
  paint_info_get_filename(-1, a);

  f = fopen(zeigeinfo_filename, "r");
  if (f == NULL) {
    return;
  }
  while (!feof(f)) {
    dosread(f, s);
    Gross(mull, s);
    if (strpos(mull, SuchStr, 0) > (int) -1) {
      kette_akt = a;
      akt = newakt;
      paint(0); // Anzeigen ohne Info Zeile
      // Info-Zeile Selber Anzeigen
      gotoxy(3, 20);
      addstr(s);
      dosread(f, s);
      gotoxy(3, 21);
      addstr(s);
      fclose(f);
      return 1;
    }
  }
  return 0;
}


suche(newakt, a)
  int newakt;
  struct adr *a;
{
  char mull[MULLLEN];

  if (kette_last == NULL)
     return;
  do
    {
      newakt++;
      Gross(mull, a->st);
      if (strpos(mull, SuchStr, 0) > (int) -1)
	{
	  kette_akt = a;
	  akt = newakt;
	  return;
	}
      if (ifstringineds(newakt, a) == 1) {
	return;
      }
      a = a->next;
    }
  while (a != kette_first);
}


suchen ()
{
  char cd[MULLLEN], mull[MULLLEN];
  struct adr *a;

  cd[0] = 0;
  sprintf(mull, "Suche Nach String");
  if (SuchStr != NULL) {
    eingabe(cd, mull, SuchStr, 0);
  } else {
    eingabe(cd, mull, " ", 0);
  }
  if (SuchStr == NULL) {
    SuchStr = (char*) malloc(1);
    SuchStr[0] = 0;
  }
  if (1)
    {
      if (0 != strcmp(cd, SuchStr))
	{
	  Gross(cd, cd);
	  free(SuchStr);
	  SuchStr = (char*) malloc(strlen(cd) + 1);
	  ps(SuchStr);
	  strcpy(SuchStr, cd);
	  a = kette_first;
	  suche(0, a);
	}
      else
	{
	  if (SuchStr != NULL)
	    {
	      a = kette_akt->next;
	      /* akt -1 wegen ++ und akt + 1 wegen dem einen nach vornespringen*/
	      suche(akt, a);
	    }
	}
    }
  paint(1);
}


wsuchen()
{
  struct adr *a;

  if (SuchStr == NULL)
    return;

  a = kette_akt->next;
  /* akt -1 wegen ++ und akt + 1 wegen dem einen nach vornespringen*/
  suche(akt, a);
}


killadr(a)
  struct adr *a;
{
  if (kette_last == NULL)
     return;

  /* Pointer umpointen */
  (a->last)->next = a->next;
  (a->next)->last = a->last;
  /* Aktuell auf neksten setzen */
  kette_akt = a->next;
  if (a == kette_last) kette_last = a->last;
  if (a == kette_first) kette_first = a->next;
  /* Knoten Lschen */
  free(a->st);
  free(a);
  /* gesamtzahl anpassen */
  ges--;
}


editds()
{
  char mull[MULLLEN], cd[MULLLEN], tempeditstr[MULLLEN], command[MULLLEN];
  int i;
  char b;

  makefnmask();
  if (kette_last == NULL)
     return;

  /*
    # ifdef BLACKY_cur_Graphik
    attrset(A_STANDOUT);
    # endif
    for (i = 1; i <= 8; i++)
    {
    gotoxy(2, (int) (i + 10));
    sprintf(mull, "%d", i);
    addstr(mull);
    }
    # ifdef BLACKY_cur_Graphik
    attrset(A_NORMAL);
    # endif


    eingabe(cd, "Welches Datenfeld mchten Sie ndern? (1-8)", "");
    b = cd[0] - 48;
  
    if (b > 0 && b < 9)
  */
    {
      sprintf(tempeditstr, "%c%c", 15, 1);
      for (i = 1; i <= 8; i++)
	{
	  /*	  if (i == b)
		  {*/
	      sprintf(mull, "ENTER %s :", GetDatenSatz(cd, FeldNamen, i));
	      GetDatenSatz(cd, kette_akt->st, i);
	      if (cd[0] == 0)
		{
		  cd[0] = ' ';
		  cd[1] = 0;
		}
	      strcat(tempeditstr, eingabe(command, mull, cd, 1));
	      /*	    }
	  else
	    {
	      strcat(tempeditstr, GetDatenSatz(command, kette_akt->st, i), (int)i);
	      }*/
	  if (i == 8)
	    {
	      sprintf(command, "%c%c", 11, 15);
	      strcat(tempeditstr, command);
	    }
	  else
	    {
	      sprintf(tempeditstr, "%s%c", tempeditstr, (char)(i + 1));
	    }
	}
      if (0 != strcmp(kette_akt -> st, tempeditstr))
	{
	  free(kette_akt->st);
	  kette_akt->st = (char*) malloc(strlen(tempeditstr) + 1);
	  pss(kette_akt->st);
	  strcpy(kette_akt->st, tempeditstr); 
	  status.ge = true;
	}
      paint(0);
    }
}


exitbdb()
{
  char cd[5];

  if (!status.ge)
    {
      gotoxy(1, 25);
      donebdb();
    }
  eingabe(cd, "ACHTUNG: Die geladene Datenbank ist nicht gespeichert. Speichern? (Y/N/A)", "", 0);
  if (toupper(cd[0]) == 'Y' || toupper(cd[0]) == 'J')
    {
      save();
      gotoxy(1, 25);
      donebdb();
    }
  if (toupper(cd[0]) == 'N')
    {
      gotoxy(1, 25);
      donebdb();
    }
}


editfn()
{
  char mull[MULLLEN], cd[MULLLEN], tempeditstr[MULLLEN], command[MULLLEN];
  int i;
  char b;

  sprintf(tempeditstr, "%c%c", 14, 1);

  if (FeldNamen == 0)
    {
      for (i = 0; i < 8; i++)
	{
	  sprintf(mull, "Geben Sie den Namen des Datenfeldes %d ein:", i + 1);
	  eingabe(cd, mull, "", 1);
	  strcat(tempeditstr, cd);
	  if (i == 7)
	    sprintf(tempeditstr, "%s%c%c", tempeditstr, 11, 14);
	  else
	    sprintf(tempeditstr, "%s%c", tempeditstr, (char)(i + 2));
	}
    }
  else
    {
#ifdef BLACKY_cur_Graphik
      attrset(A_STANDOUT);
#endif
      for (i = 1; i <= 8; i++)
	{
	  gotoxy(2, (int)(i + 10));
	  sprintf(mull, "%d", i);
	  addstr(mull);
	}
#ifdef BLACKY_cur_Graphik
      attrset(A_NORMAL);
#endif
      strcpy(cd, FeldNamen);
      eingabe(cd, "Welchen FeldNamen mchten Sie ndern? (1-8)", "", 0);
      b = cd[0] - 48;
      if (b > 0 && b < 9)
	{
	  for (i = 1; i <= 8; i++)
	    {
	      if (i == b)
		{
		  sprintf(mull, "Ersetze \"%s\" durch :",
			  GetDatenSatz(command, FeldNamen, b));
		  GetDatenSatz(cd, FeldNamen, b);
		  if (cd[0] == 0)
		    {
		      cd[0] = ' ';
		      cd[1] = 0;
		    }
		  strcat(tempeditstr, eingabe(command, mull, cd, 1));
		}
	      else
		{
		  strcat(tempeditstr, GetDatenSatz(mull, FeldNamen, (int)i));
		}
	      if (i == 8)
		{
		  sprintf(tempeditstr, "%s%c%c", tempeditstr, 11, 14);
		}
	      else
		{
		  sprintf(tempeditstr, "%s%c", tempeditstr, (char)(i + 1));
		}
	    }
	}
      else
	return;
    }
  if (FeldNamen != 0)
    {
      if (strcmp(FeldNamen, tempeditstr) == 0)
	{
	  return;
	}
      free(FeldNamen);
    }
  FeldNamen = (char*) malloc(strlen(tempeditstr) + 1);
  pss(FeldNamen);
  strcpy(FeldNamen, tempeditstr);
  status.ge = true;
  maxdfbez = 0;
  paint(1);
}


saveas()
{
  char mull[MULLLEN], cd[MULLLEN];
  int i;

  if (kette_last == NULL)
     return;
  strcpy(mull, "Geladene Datenbank Speichern Unter (* = != bdb) (ESC ENTER fr Abbrechen): ");
  if (datei != NULL)
    eingabe(cd, mull, datei, 1);
  else
    eingabe(cd, mull, "namenlos.bdb", 1);

  if (cd[0] == 0) return;

  if (cd[strlen(cd) - 1] != '*')
    {
      if (cd[strlen(cd) - 4] != '.')
	{
	  if (cd[strlen(cd) - 1] != '.')
	    {
	      strcat(cd, ".bdb");
	    }
	}
    }
  else
    cd[strlen(cd) - 1] = 0;
  free(datei);
  datei = (char*) malloc(strlen(cd) + 1);
  pss(datei);
  strcpy(datei, cd);
  save();
  paint(1);
}


dsnext()
{
  if (kette_last == NULL)
     return;
  kette_akt = kette_akt->next;
  akt++;
  if (akt > ges)
    akt = 1;
  paint(1);
}


dstohome()
{
  if (kette_last == NULL)
     return;
  kette_akt = kette_first;
  /* akt = 1; (erlediigt paint) */
  paint(1);
}


dstoend()
{
  if (kette_last == NULL)
     return;

  kette_akt = kette_last;
  /* akt = ges; (erlediigt paint) */
  paint(1);
}


dslast()
{
  if (kette_last == NULL)
     return;

  kette_akt = kette_akt->last;
  akt--;
  if (akt < 1)
    akt = ges;
  paint(1);
}


dsnew()
{
  char mull[MULLLEN], tempeditstr[MULLLEN], command[MULLLEN];
  int i;

  akt = 0;
  sprintf(tempeditstr, "%c%c", 15, 1);
  for (i = 1; i <= 8; i++)
    {
      if (FeldNamen != NULL)
         GetDatenSatz(command, FeldNamen, (int)i);
      else
         command[0] = 0;
      sprintf(mull, "Abfrage: ENTER %s : (\".\" + ENTER = Abb.)", command);
      strcat(tempeditstr, eingabe(command, mull, " ", 0));
      if (command[strlen(command) - 1] == '.')
	return;
      if (i == 8)
	{
	  sprintf(command, "%c%c", 11, 15);
	  strcat(tempeditstr, command);
	}
      else
	{
          strcpy(mull, tempeditstr);
	  sprintf(tempeditstr, "%s%c", mull, (char)(i + 1));
	}
    }
  kette_akt = newadr(tempeditstr);
  status.ge = true;
  paint(1);
}


dskill()
{
  char cd[5];

  if (kette_last == NULL)
     return;
  paint(0);
  eingabe(cd, "Sind Sie sicher das Sie den Aktuellen Datensatz Lschen wollen? (Y/N):", "", 0);
  if (toupper(cd[0]) == 'J' || toupper(cd[0]) == 'Y')
    {
      killadr(kette_akt);
      status.ge = true;
    }
  paint(1);
}


editdbname()
{
  char mull[MULLLEN], cd[MULLLEN];

  strcpy(mull, "Geben Sie den neuen Namen der Datenbank ein. ENTER fr den alten.");
  if (Name != 0)
    {
      eingabe(cd, mull, Name, 1);
      if (0 == strcmp(cd, Name))
	return;
      free(Name);
    }
  else
    eingabe(cd, mull, " ", 0);
  if (cd[0] == 0)
    return;
  Name = (char*) malloc(strlen(cd) + 1);
  pss(Name);
  strcpy(Name, cd);
  status.ge = true;
  paint(1);
}


setsort()
{
  char cd[MULLLEN];
  int i;

  eingabe(cd, "Nach welchem Datenfeld soll sorirt werden? (1-8)", "", 0);
  if (cd[0] != 0)
    {
      i = atoi(cd);
      if (i < 9 && i > 0)
	{
	  status.sort = i - 1;
	  status.ge = true;
	  eingabe(cd, "Die Sortierung wirkt sich erst beim neu laden aus !", "", 0);
	}
    }
}


donebdb()
{
  char mull[MULLLEN];

  if (status.ge)
    {
      if (datei == NULL)
	{
	  sprintf(mull, "%s%s%c", getenv("HOME"), "/NAMENLOS.BDA", 0);
	  datei = (char *) malloc(strlen(mull) + 1);
	  strcpy(datei, mull);
	}
      else
	{
	  datei[strlen(datei) - 1] = datei[strlen(datei) - 1] - 1;
	}
      save();
    }
  finish(1);
}


drucken_a_lot_of(s, m, z)
  char s[], z;
  int m;
{
  int i;

  for (i = 0; i < m; i++)
    {
      if (s[i] != z)
	s[i] = z;
    }
  s[i] = 0;
}


drucken()
{
  int z, i, j,  x[8];
  char au[8];
  struct adr *a;
  FILE *f;
  char s0[60], s[MULLLEN], mull[MULLLEN], wohin[MULLLEN], command[MULLLEN];
  char m;

  /* Langenarray auf NULL setzen */
  for (i = 0; i <= 7; i++)
    {
      x[i] = 0;
      au[i] = i;
    }
  /* Wenn Keine Datenbank Geladen, dann EXIT */
  if (kette_first == NULL)
    return;
  /* Laden der prn File, wenn verhanden. */
  sprintf(wohin, "%s.prn", datei);
  f = fopen(wohin, "r");
  j = 0;
  if (f == NULL)
    j = 0;
  else
    {
      eingabe(mull, "Mchten Sie die alten Configurationen Benutzen (y/n)? (\".\" + ENTER = Abb.)", "y", 1);
      if (mull[strlen(mull) - 1] == '.')
	return;
      if (toupper(mull[0]) == 'Y')
	j = 1;
      if (toupper(mull[0]) == 'J')
	j = 1;
    }
  if (j == 1)
    {
      fread(&x, sizeof(x), 1, f);
      readastring(f, wohin);
      fread(au, 8, 1, f);
      if (fread(&m, 1, 1, f) != 1) m = 0;
      fclose(f);
      f = NULL;
    }
  else
    {
      /* Standart Druckeroutput */
      strcpy(wohin, " ");
      /* Ermitteln der Lngen */
      a = kette_first;
      do
	{
	  for (i = 1; i <= 8; i++)
	    {
	      j = strlen(GetDatenSatz(mull, a->st, i));
	      if (j > x[i - 1])
		x[i - 1] = j;
	    }
	  a = a->next;
	}
      while (a != kette_first);
    }
  do
    {
      clear();
      addstr(">");
      for (i = 1; i <= 8; i++)
	{
	  if (x[au[i - 1]] != 0)
	    {
	      GetDatenSatz(mull, FeldNamen, au[i - 1] + 1);
	      mull[x[au[i - 1]]] = 0;
	      sprintf(s, "  %c-%ds", '%', x[i - 1]);
	      sprintf(command, s, mull);
	      addstr(command);
	    }
	}
      addstr("<\n\n");
      addstr("Modus: ");
      if (m == 0) addstr("normal\n\n");
      if (m == 1) addstr("DOS - GRA\n\n");
      for (i = 0; i < 8; i++)
	{
	  s0[0] = i + 97;
	  s0[1] = 0;
	  addstr("  ");
	  addstr(s0);
	  addstr("-");
	  addstr(GetDatenSatz(mull, FeldNamen, au[i] + 1));
	  sprintf(mull, "-%d; ", x[au[i]]);
	  addstr(mull);
	}
      addstr("\n\n");
      addstr("Mchten sie diese Gre Beibehalten?\n  Drcken sie ENTER fr ja, oder die Zahlen von 1-8, um die Lnge zu editiren!\n  Drcken Sie a - h, um eines der Druck felder Neu zu belegen !\n  M - Modus\n\n  ESC - ABBRECHEN\n");
      j = getch();
      if ((j > 48) && (j < 57))
	{
	  i = 0;
	  for (z = 0; z <= 7; z++)
	    i = i + 2 + x[z];
	  z = j - 48;
	  sprintf(mull, "\nNeue Breite des Datenfeldes %s. In Zeichen. (Gesamt: %d) (%d)", GetDatenSatz(command, FeldNamen, z), i, x[au[z - 1]]);
	  addstr(mull);
	  sprintf(s, "%d", x[au[z - 1]]);
	  editstr(s, 20, 0, 1);
	  /*	  if (atoi(s) != 0) */
	  x[z - 1] = atoi(s);
	}
      if ((j > 96) && (j <105))
	{
	  sprintf(mull, "\nTabelle: XXXX\n  A  B  C  D  E  F  G  H\n  ------------------------\n  %d  %d  %d  %d  %d  %d  %d  %d", au[0] + 1, au[1] + 1, au[2] + 1, au[3] + 1, au[4] + 1, au[5] + 1, au[6] + 1, au[7] + 1);
	  addstr(mull);
	  sprintf(mull, "\nWelches Datenfeld soll an %c Gedruckt Werden ? (1 - 8): ", j);
	  addstr(mull);
	  echo();
	  /*getstr(mull);*/
	  /*i = getch();*/
	  eingabe(mull, "", "", 0);
	  noecho();
	  z = j - 97; /* -96 Ascii; -1 */
	  if ((mull[0] > 48) && (mull[0] < 57))
	    au[z] = mull[0] - 49; /* -48 Wegen Ascii; -1 wegen 0 - 7*/
	}
      if (toupper(j) == 'M')
	{
	  sprintf(s, "\nENTER MODUS:\n  0.) Normal\n  1.) DOS-Graphik\n");
	  addstr(s);
	  eingabe(mull, "", "", 0);
	  if ((mull[0] > 47) &&(mull[0] < 50))
	  m = (mull[0] - 48);
	}
      if (j == 27)
	{
	  paint(1);
	  return;
	}
    }
  while (j != 13);
  paint(0);
  /* Zieldatei Feststellen, und ffnen */
  strcpy(mull, wohin);
  eingabe(wohin, "Wohin mit der Ausgabe ?", mull, 1);
  bsk(wohin);
  f = fopen(wohin, "w");
  fprintf(f, "Tabelle: %s\n", Name);
  /* Kopfzeile, nur bei DOS-GRA */
  if (m == 1)
    {
      fprintf(f, "%c<  %c%c", 27, 201, 205);
      for (i = 0; i < 8; i++)
	{
	  if (x[au[i]] != 0)
	    {
	      drucken_a_lot_of(mull, x[au[i]], 205);
	      if (i != 0)
		fprintf(f, "%c%c%s%c", 209, 205, mull, 205);
	      else
		fprintf(f, "%s%c", mull, 205);
	    }
	}
      fprintf(f, "%c%c%c", 187, 13, 10);
      fprintf(f, "%c<  %c ", 27, 186);
    }
  /* Schreiben der FeldNamen */
  for (i = 1; i <= 8; i++)
    {
      if (x[au[i - 1]] != 0)
	{
	  GetDatenSatz(mull, FeldNamen, au[i - 1] + 1);
	  mull[x[au[i - 1]]] = 0;
	  if (m == 0)
	    {
	      if (i == 1)
		fwrite(" ", 1, 1, f);
	      sprintf(s, " %c-%ds", '%', x[au[i - 1]]);
	      fprintf(f, s, mull);
	    }
	  else
	    {
	      strcpy(mull, todos(mull));
	      sprintf(s0, "%c-%ds", '%', x[au[i - 1]]);
	      sprintf(s, s0, mull);
	      if (i != 1)
		fprintf(f, "%c %s ", 179, s);
	      else
		fprintf(f, "%s ", s);
	    }
	}
    }
  if (m == 0)
    fprintf(f, "\n");
  if (m == 1)
    fprintf(f, "%c%c%c%c<  %c%c", 186, 13, 10, 27, 204, 205);
  /* Schreiben der Trennlinie */
  for (i = 0; i < 8; i++)
    {
      if (x[au[i]] != 0)
	{
	  if (m == 0)
	    {
	      drucken_a_lot_of(mull, x[au[i]], '-');
	      if (i == 0)
		fprintf(f, "  %s", mull);
	      else
		fprintf(f, "-%s", mull);
	    }
	  if (m == 1)
	    {
	      drucken_a_lot_of(mull, x[au[i]], 205);
	      if (i != 0)
		fprintf(f, "%c%c%s%c", 216, 205, mull, 205);
	      else
		fprintf(f, "%s%c", mull, 205);
	    }
	}
    }
  if (m == 0)
    fprintf(f, "\n");
  if (m == 1)
    fprintf(f, "%c%c%c", 185, 13, 10);
  /* Schreiben der Datenstze */
  a = kette_first;
  do
    {
      if (m == 1)
	fprintf(f, "%c<  %c ", 27, 186);
      for (i = 1; i <= 8; i++)
	{
	  if (x[au[i - 1]] != 0)
	    {
	      GetDatenSatz(mull, a -> st, au[i - 1] + 1);
	      mull[x[au[i - 1]]] = 0;
	      if (m == 0)
		{
		  if (i == 1)
		    fwrite(" ", 1, 1, f);
		  sprintf(s, " %c-%ds", '%', x[au[i - 1]]);
		  fprintf(f, s, mull);
		}
	      else
		{
		  strcpy(mull, todos(mull));
		  sprintf(s0, "%c-%ds", '%', x[au[i - 1]]);
		  sprintf(s, s0, mull);
		  if (i != 1)
		    fprintf(f, "%c %s ", 179, s);
		  else
		    fprintf(f, "%s ", s);
		}
	    }
	  if (i == 8)
	    {
	      if (m == 1)
		fprintf(f, "%c%c%c", 186, 13, 10);
	      if (m == 0)
		fprintf(f, "\n");
	    }
	}
      a = a->next;
    }
  while (a != kette_first);
  /* Fuzeile, nur bei DOS-GRA */
  if (m == 1)
    {
      fprintf(f, "%c<  %c%c", 27, 200, 205);
      for (i = 0; i < 8; i++)
	{
	  if (x[au[i]] != 0)
	    {
	      drucken_a_lot_of(mull, x[au[i]], 205);
	      if (i != 0)
		fprintf(f, "%c%c%s%c", 207, 205, mull, 205);
	      else
		fprintf(f, "%s%c", mull, 205);
	    }
	}
      fprintf(f, "%c%c%c", 188, 13, 10);
    }
  /* Schlien */
  fflush(f);
  fclose(f);
  /* Sichern der Druckerconfig */
  sprintf(mull, "%s.prn", datei);
  f = fopen(mull, "w");
  fwrite(&x, sizeof(x), 1, f);
  writeastring(f, wohin);
  fwrite(au, 8, 1, f);
  fwrite(&m, 1, 1, f);
  fflush(f);
  fclose(f);
}


func()
{
  FILE *f;
  int i, i2;
  char mull[MULLLEN], cd[MULLLEN], tempeditstr[MULLLEN], command[MULLLEN];
  char b;

  f = fopen("/dev/urandom", "r");
  fread(&i2, 2, 1, f);
  fclose(f);  
  i = getch() - 48;
  if ((i > 8) || (i < 1)) return;
  if (datei == NULL) return;
  sprintf(mull, "%s.%d.rc", datei, i);
  f = fopen(mull, "r");
  mull[0] = 0;
  if (f != 0)
    {
      dosread(f, cd);
      fclose(f);
      f = NULL;
      sprintf(mull, "xterm -e %s /tmp/.bdb.temp.%d", cd, i2);
      system(mull);
      eingabe(mull, "Laden und Einfgen der Daten ? (y/n)",
	      "y", 1);
      if ((mull[0] == 'y') || (mull[0] == 'Y'))
	{
	  sprintf(mull, "/tmp/.bdb.temp.%d", i2);
	  f = fopen(mull, "r");
	  if (f == NULL)
	    {
	      eingabe(mull, "Can't read file!", mull, 0);
	      remove(mull);
	      return;
	    }
	  dosread(f, cd);
	  fclose(f);
	  f = NULL;
	  b = i;
	  strcpy(tempeditstr, "\017\001");
	  for (i = 1; i <= 8; i++)
	    {
	      if (i == b)
		{
		  strcat(tempeditstr, cd);
		}
	      else
		{
		  strcat(tempeditstr, GetDatenSatz(command, kette_akt->st, i),
			 (int)i);
		}
	      if (i == 8)
		{
		  sprintf(command, "%c%c", 11, 15);
		  strcat(tempeditstr, command);
		}
	      else
		{
		  sprintf(tempeditstr, "%s%c", tempeditstr, (char)(i + 1));
		}
	    }
	  if (0 != strcmp(kette_akt -> st, tempeditstr))
	    {
	      free(kette_akt->st);
	      kette_akt->st = (char*) malloc(strlen(tempeditstr) + 1);
	      pss(kette_akt->st);
	      strcpy(kette_akt->st, tempeditstr); 
	      status.ge = true;
	    }
	  paint(1);
	}
      sprintf(mull, "/tmp/.bdb.temp.%d", i2);
      remove(mull);
    }
}


printakds()
{
  FILE *f;
  char cd0[50], cd1[50], cd2[50], b;
  int i;
  char mull[MULLLEN];

  sprintf(cd1, "%s%s%c", getenv("HOME"), "/.stdprn.ahp", 0);
  f = fopen(cd1, "r");
  if (f != NULL)
    readastring(f, cd0);
  else
    cd0[0] = 0;
  fclose(f);
  eingabe(cd2, "Mchten Sie den Aktuellen DS drucken? Wohin? (\".\" + ENTER = Abbrechen)",
	  cd0, 1);
  if (cd2[strlen(cd2) - 1] == '.')
    return;
  f = fopen(cd1, "w");
  writeastring(f, cd2);
  fflush(f);
  fclose(f);
  f = fopen(cd2, "w");
  b = 0;
  if ((kette_akt != NULL) && (FeldNamen != 0) && (Name != NULL) && (f != NULL))
    {
      for (i = 1; i <= 8; i++)
	{
	  GetDatenSatz(cd2, FeldNamen, i);
	  if ((int) strlen(cd2) >= b)
	    {
	      b = strlen(cd2);
	    }
	}
      fprintf(f, "Blacky Daten Bank: %s%c%c", todos(Name), 13, 10);
      for (i = 1; i <= 8; i++)
	{
	  if (kette_akt->st != NULL)
	    {
	      GetDatenSatz(mull, kette_akt->st, i);
	      if (strlen(mull) > 0)
		{
/*sprintf(mull, "\n\n\n\n>>%d<<\n\n\n\n", FeldNamen);*/
/*addstr(mull);*/
/*exit(0);*/
		  GetDatenSatz(mull, FeldNamen, i);
	          sprintf(cd2, "%s                                             ",
			  mull);
		  fprintf(f, "  %.*s:", b, todos(cd2));
		  GetDatenSatz(mull, kette_akt->st, i);
		  fprintf(f, " %.*s%c%c", 60 - b, todos(mull), 13, 10);
	        }
	    }
	}
      /*      fflush(f);*/
      ffsync(f);
      fclose(f);
    }  
}


wahl()
{
  int feld = 0, i;
  char mull[MULLLEN];
  FILE *f;
  char *command;

  for (i = 1; i <= 8; i++)
    {
      GetDatenSatz(mull, FeldNamen, i);
      if (strncasecmp(mull, "tele", 4) == 0)
	{
	  feld = i;
	  break;
	}
    }
  if (feld == 0)
    {
      makeline(VLINE, NOMBG, VLINE, 1, 20);
      makeline(VLINE, NOMBG, VLINE, 1, 21);
      gotoxy(3, 20);
      addstr("Kein Feld fr Telefonnummer definirt! Feldname mu mit tele beginnen!");
      for (  ; !(i == 13 || i == 32); i = getch())
	;
      return;
    }
  command = (char *) getenv("BDB_MODEMWAHL_COMMAND");
  if (command != 0)
    {
      makeline(VLINE, NOMBG, VLINE, 1, 20);
      makeline(VLINE, NOMBG, VLINE, 1, 21);
      gotoxy(3, 20);
      addstr("Starte Commando fr den Modem-Gebrauch ... Bitte warten...");
      system(command);
      //      free(command);
    }
  f = fopen("/dev/blacky_modem", "w");
  if (f == NULL)
    {
      f = fopen("/dev/modem", "w");
      if (f == NULL)
	{
	  makeline(VLINE, NOMBG, VLINE, 1, 20);
	  makeline(VLINE, NOMBG, VLINE, 1, 21);
	  gotoxy(3, 20);
	  addstr("Konnte Modem (/dev/modem) nicht ffnen!");
	  for (  ; !(i == 13 || i == 32); i = getch())
	    ;
	  return;
	}
    }
  GetDatenSatz(mull, kette_akt->st, i);
  for (i = 0; ((mull[i] != ' ') && (mull[i] != 0)); i++)
    ;
  mull[i] = 0;
  fprintf(f, "+++ATZ%c", 13);
  //  fprintf(f, "AT S7=45 S0=0 L1 V1 X4 &c1 E1 Q0%c\n", 13);
  fflush(f);
  /*  fscanf(f, "%s", mull);
  if (strncmp(mull, "OK", 2) != 0) {
    makeline(VLINE, NOMBG, VLINE, 1, 20);
    makeline(VLINE, NOMBG, VLINE, 1, 21);
    gotoxy(3, 20);
    addstr("ERROR (/dev/modem): ");
    addstr(mull);
    for (  ; !(i == 13 || i == 32); i = getch())
      ;
    return;
    }*/
  sleep(4);
  fprintf(f, "ATDT%s%c", mull, 13);
  fflush(f);
  /*  fclose(f);*/
  makeline(VLINE, NOMBG, VLINE, 1, 20);
  makeline(VLINE, NOMBG, VLINE, 1, 21);
  gotoxy(3, 20);
  addstr("Whle jetzt die Nummer... (Nehmen Sie den Hhrer ihres Telefons ab, warten");
  gotoxy(3, 21);
  addstr("Sie bis gewht wurde und drcken dann eine SPACE.");
  for (  ; !(i == 13 || i == 32); i = getch())
    ;
  /*  f = fopen("/dev/modem", "w");*/

  fprintf(f, "+++ATZ%c", 13);
  fflush(f);
  //  fprintf(f, "x\n");
  //  fflush(f);
  fclose(f);
  paint(1);
}


main(argc, argv)
  int argc;
  char *argv[];
{
  char command[MULLLEN];
  FILE *f;

  allblackyintro(blacky_ver_info);

  if ((argc > 1) ? ((argv[1][0] == '-') && ((argv[1][1] == '?') || (toupper(argv[1][1]) == 'H'))) : 0) {
    printf("Help:\n");
    printf("  l_bdb <<file> [-a] [-u] | <-v>>\n");
    printf("    -a: Schreibt DatenBanken im altem format\n");
    printf("    -u: Unterdrckt das Anzeigen der Info-Datein (Fr Langsame Rechner)\n");
    printf("    -v: Version, Licenze\n");
    exit(0);
  }

  if ((argc > 2) ? ((argv[2][0] == '-') && (toupper(argv[2][1]) == 'A')) : 0) {
    wto = 1;
  }
  if ((argc > 2) ? ((argv[2][0] == '-') && (toupper(argv[2][1]) == 'U')) : 0) {
    zeigeinfo = 0;
  }
  if ((argc > 3) ? ((argv[3][0] == '-') && (toupper(argv[3][1]) == 'U')) : 0) {
    zeigeinfo = 0;
  }

  if ((argc == 2) ? ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'V')) : 0) {
    printf("%s\n\n", blacky_ver_info);
    printkinfo(stdout);
    exit(0);
  }

  /* Editor? */
  EDITOR = (char *) getenv("EDITOR");
  if (EDITOR == NULL) {
    EDITOR = (char *) malloc(3);
    if (EDITOR == NULL) {
      perror("malloc()");
      exit(1);
    }
    strcpy(EDITOR, "vi");
  }
  EDITOR2 = (char *) getenv("EDITOR2");
  if (EDITOR2 == NULL) {
    EDITOR2 = (char *) malloc(11);
    if (EDITOR2 == NULL) {
      perror("malloc()");
      exit(1);
    }
    strcpy(EDITOR2, "xemacs -nw");
  }


  init_cur_graph();

  /* Interrups vergeben ... */
  signal(SIGHUP, finish);       /* 01  /  hangup     - Alt-F4                            */
  signal(SIGINT, finish);       /* 02  /  Interrupt  - ^C                                */
  signal(SIGQUIT, finish);      /* 03  /  Quit                                           */
  signal(SIGTERM, finish);      /* 15  /  Terminierung                                   */
  /*     SIGALRM  */
  signal(SIGALRM, uhr);         /* 14  /  Alarm      - wenn gesetzte Zeit abgelaufen ist */
  /* Fenstergre gendert? */
  signal(SIGWINCH, winversch);  /* 28  /  ?          - grennderund des xTerms         */
  status.swhg = 0;
  kette_first = NULL;
  kette_last = NULL;
  kette_akt = NULL;
  akt = 1;
  FeldNamen = NULL;
  SuchStr = NULL;
  Name = NULL;
  status.sort = 0;
  status.ge = false;
  if (argc > 1) {
    /* Prfen, ob die Parameterdatei existiert */
    if ((f = fopen(argv[1], "r")) != NULL) {
      fclose(f);
      f = NULL;
      load(argv[1]);
    } else {
      /* Hate der User villeicht '.bdb' vergessen */ 
      strcpy(command, argv[1]);
      strcat(command, ".bdb");
      if ((f = fopen(command, "r")) != NULL) {
	fclose(f);
	f = NULL;
	load(command);
      } else {
	/* Oder '.BDB' ? */
	strcpy(command, argv[1]);
	strcat(command, ".BDB");
	if ((f = fopen(command, "r")) != NULL) {
	  fclose(f);
	  f = NULL;
	  load(command);
	} else {
	  /*                     sprintf(command, "%cFehler beim laden der Datei : %s !\n", 0x7, argv[1]);
				 finish(-2);*/
	  eingabe(command, "Die Datei Existiert nicht! Wird angelegt!", "", 0);
	  if ((f = fopen(argv[1], "w")) == NULL) {
	    eingabe(command, "Die Datei konnte nicht angelegt werden!", "", 0);
	    finish(-2);
	  }
	  fclose(f);
	  makefnmask();
	  datei = argv[1];
	  //		     datei = (char *) malloc(strlen(argv[1]) + 1);
	  //		     pss(datei, argv[1]);
	  //		     strcpy(datei, argv[1]); 
	}
      }
    }
  } else {
    fprintf(stderr, "Help\n  D_BDB <datenbank>\n\n\nNeue Datenbank !");
  }
  paint(0);
  /* ABSOLUTELY NO WARRANTY */
  gotoxy(3, 20);
  addstr("This is free software with ABSOLUTELY NO WARRANTY.");
  gotoxy(3, 21);
  addstr("For details read /home/andreas/.Blacky_NO_WARRANTY.");
  /* UHR */
  alarm(1);
  /* x-Term-Titel */
  blacky_xterm_set_titel("Blacky Daten Bank", datei);
  /* Hauptschleife */
  do
     {
       gotoxy(14, 23);
       switch (getch())
         {
	    /* Functionen ! - [1 - 8] */
	    case '!':
	      func();
	    break;

	    /* Feldnamen Editiren - 'F' || 'f' */ 
	    case 70:
	    case 102:
	      editfn();
	    break;

	    /* Datenbanknamen ndern - 'N' || 'n' */
	    case 78:
	    case 110:
	      editdbname();
	    break;

            /* Sortierung festlegen - 'S' || 's' */
            case 115:
            case 83:
              setsort();
            break;

	    /* DS Editiren - 'ENTER' */
	    case 13:
	    case 343:
	      editds();
	    break;

	    /* exit - 'ESC' || 'ALT-X' */
	    case 27:
	    case 'x':
	    case 'X':
	    case 'q':
	    case 'Q':
	      exitbdb();
	    break;

	    /* DE PLUS - 'UP' oder '+' */
	    case 259:
            case '+':
	      dsnext();
	    break;
	      
	    /* DS LAST - 'DN' oder '-' */
	    case 258:
            case '-':
	      dslast();
	    break;

	    /* new DS - 'INS' oder 'I' */
	    case 331:
	    case 'I':
	      dsnew();
	    break;

	    /* info (licenze) */
	 case 'i':
	   {
	     char file[] = "/tmp/.Blacky__NO_WARRANTY_and_Pinfo";
	     char ss[500];
	     FILE *f;

	     makeline(VLINE, NOMBG, VLINE, 1, 20);
	     makeline(VLINE, NOMBG, VLINE, 1, 21);
	     //	     gotoxy(3, 20);
	     //	     addstr("Lade Info-Datei, Bitte Warten...");

	     f = fopen(file, "w");
	     if (f == NULL) {
	       uhr(1);
	       break;
	     }
	     fprintf(f, "%s\n\n", blacky_ver_info);
	     printkinfo(f);
	     ffsync(f);
	     fclose(f);

	     sprintf(ss, "%s %s\n", EDITOR, file);

	     //	     runcommand = (char *) malloc(strlen(ss));
	     //	     if (runcommand == NULL)
	     //	       {
	     //		 break;
	     //	       }
	     //	     strcpy(runcommand, ss);

	     alarm(0);
	     endwin();
	     system(ss);
	     alarm(1);
	     uhr(1);
	   }
	   break;

	    /* del DS - 'DEL' oder 'k' */
	    case 330:
            case 'k':
	    case 'K':
	      dskill();
	    break;

	    /* to first ds - 'HOME' */
	    /*  case 49:
		if (getchar() != 126)
		break; */
	    case 72:
	    case 262:
	      dstohome();
	    break;

	    /* to last ds - 'END' */
	    /*	    case 70: */
	    case 360:
	      dstoend();
	    break;

	    /* Save - F2 oder 'w' */
	    case 266:
            case 'w':
	    case 'W':
	      save();
	      paint(1);
	    break;

	    /* Weitersuchen */
	    case 'r':
	    case 'R':
	      wsuchen();
	    break;
	      

	    /* Suchen - F3 oder '/' */
	    case 267:
            case '/':
	      suchen();
	    break;

	    /* Save As - F4 oder 'a' */
	    case 268:
            case 'a':
            case 'A':
	      saveas(); 
	    break;

	    /* Drucken = 'D' || 'd' */
	    case 100:
	    case 68:
	      drucken();
	    break;

	    /* Drucken des Acktuellen DS = 'p' || 'P' */
	    case 'p':
	    case 'P':
	      printakds();
	    break;

	    /* Redraw - Space */
            case ' ':
	      endwin();
	      paint(1);
	    break;

	    case '?':
	      {
		int i;
		FILE *f;
		char cd[500];

		makeline(VLINE, NOMBG, VLINE, 1, 20);
		makeline(VLINE, NOMBG, VLINE, 1, 21);
		//		gotoxy(3, 20);
		//		addstr("Lade Info-Datei, Bitte Warten...");

		paint_info_get_feld();
		paint_info_get_filename(akt, kette_akt);

		endwin();

		//		runcommand = (char *) malloc(strlen(zeigeinfo_filename) + strlen(EDITOR) + 2);
		//		if (runcommand == NULL) {
		//		  break;
		//		}
		alarm(0);
		//		strcpy(runcommand, EDITOR);
		//		strcat(runcommand, " ");
		//		strcat(runcommand, zeigeinfo_filename);
		sprintf(cd, "%s %s", EDITOR, zeigeinfo_filename);
		system(cd);
		//		free(runcommand);
		alarm(1);
		paint(1);
	      }
	    break;

	    case '_':
	      {
		int i;
		FILE *f;
		char cd[500];

		makeline(VLINE, NOMBG, VLINE, 1, 20);
		makeline(VLINE, NOMBG, VLINE, 1, 21);
		//		gotoxy(3, 20);
		//		addstr("Lade Info-Datei, Bitte Warten...");

		paint_info_get_feld();
		paint_info_get_filename(akt, kette_akt);

		endwin();

		//		runcommand = (char *) malloc(strlen(zeigeinfo_filename) + strlen(EDITOR) + 2);
		//		if (runcommand == NULL) {
		//		  break;
		//		}
		alarm(0);
		//		strcpy(runcommand, EDITOR);
		//		strcat(runcommand, " ");
		//		strcat(runcommand, zeigeinfo_filename);
		sprintf(cd, "%s %s", EDITOR2, zeigeinfo_filename);
		system(cd);
		//		free(runcommand);
		alarm(1);
		paint(1);
	      }
	    break;


            case 261:
	      paint_info_newline();
	    break;

	    /* Via Modem Whlen (Funkttioniert nur bei Adressen) */
	    case 'C':
	    case 'c':
	      wahl();
	    break;	    

	    /* Wenn keine bekannte Taste gedrckt wurde */
	    default:
	      /*endwin();*/
	      paint(1);
	    break;

         } /* END CASE */     
   } while (1);

  /*
   GoToXY(50, 5);
   X := von Rechtz
   Y := von Links
  */

  /* move(o, l) :
      Bei NULL beginnend !!!
      o = von oben;
      l = von links; */
}


static void uhr(int sig)
{
  static long ti;
  static struct tm *tminfo;
  static char st[3], min[3], sec[3], outstr[9];
  static int x, y;

  if (runcommand != NULL)
      {
	endwin();
	system(runcommand);
	free(runcommand);
	runcommand = NULL;
	paint(1);
      }

  if (status.swhg)
    return;

  /* Ngster aufruf, nur von einem signal aufruf ! */
  if (sig != 128)
    {
      signal(SIGALRM, uhr);
      alarm(1);
    }
  getsyx(y, x);
  /* Get Time Date */
  ti = time(&ti);
  tminfo = localtime(&ti);
  /* Copyren der Zahlen in einen String, und 0 davorsetzen */
  sprintf(st, "%d", tminfo -> tm_hour);
  make0(st, 2);
  sprintf(min, "%d", tminfo -> tm_min);
  make0(min, 2);
  sprintf(sec, "%d", tminfo -> tm_sec);
  make0(sec, 2);
  /* Ausgabestring vofmatieren */
  sprintf(outstr, "%s:%s:%s", st, min, sec);
  /* Ausgeben */
  gotoxy(65, 10);
  addstr(outstr);
  /*  gotoxy(14, 23); */
  setsyx(y, x);
  refresh();
}


static void winversch(int sig)
{
  signal(SIGWINCH, winversch);
  printf("%c", 7);
  endwin();
  paint(1);
}


static void finish(int sig)
{
  char cd[MULLLEN];

  status.swhg = 1;

  /* Spichern Befor beenden, wenn gendert */
  if (status.ge)
    {
      /* Dateinamen ndert, um zu verhindern, das die alte Datei
	 berschrieben wird */
      if (datei == NULL)
	 {
	   sprintf(cd, "%s%s%c", getenv("HOME"), "/NAMENLOS.BDC", 0);
	   datei = (char *) malloc(strlen(cd) + 1);
	   strcpy(datei, cd);
	 }
      else
	 {
	   datei[strlen(datei) - 1] = datei[strlen(datei) - 1] + 1;
	 }
      save();
    }
  /* Letzte Rettung, wenn's nicht geklapt hat werden die Daten ins Home
     geschrieben */
  if (status.ge)
    {
      sprintf(cd, "%s%s%c", getenv("HOME"), "/NAMENLOS.LR", 0);
      datei = (char *) malloc(strlen(cd) + 1);
      strcpy(datei, cd);
      save();
      datei = (char *) malloc(22);
      strcpy(datei, "/tmp/NAMENLOS.BDB.LR");
      save();
    }
  /* Herrunterfahren */
  endwin();
  /* x-Term-Titel */
  blacky_xterm_set_titel("xterm", 0L);
  /* Error - Rckgabe */
  printf("Blacky Daten Bank wurde Herruntergefahren (%d)...\n", sig);
  if (sig < 0)
    {
      if (sig == -1)
	fprintf(stderr, "** FEHLER ** : Nicht gengent Speicher!\n");
      if (sig == -2)
	fprintf(stderr, "** FEHLER ** beim ffnen der Datei!\n");
      exit(1);
    }
  exit(0);
}
